/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20140715

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "gram.y"
/* $Header$ */

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 1 shift/reduce conflict and 4 reduce/reduce:
 * 
 * 2 reduce/reduce conflicts on:
 *
 *	    *int . func 
 *	    **int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 * 2 reduce/reduce conflicts on:
 *
 *	   &int . func
 *	   &&int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers.
 *	(Of course, you can always enclose an assignment in parens.)
 *      (I can't see any obvious way to use operator precedence to
 *      get rid of this: seems like you'd need to duplicate simpleexpr
 *      with different precedence. --BCM)
 *
 */
int ignorenl;
int notCommand;
int seeComment;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static Expr *
ParseCanonFor (Expr *expr);

static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);

#line 72 "gram.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 118 "gram.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define VAR 257
#define EXPR 258
#define ARRAY 259
#define STRUCT 260
#define UNION 261
#define ENUM 262
#define COMP 263
#define HASH 264
#define SEMI 265
#define MOD 266
#define OC 267
#define CC 268
#define DOLLAR 269
#define DOTDOTDOT 270
#define ENDFILE 271
#define GLOBAL 272
#define AUTO 273
#define STATIC 274
#define CONST 275
#define POLY 276
#define INTEGER 277
#define NATURAL 278
#define RATIONAL 279
#define REAL 280
#define STRING 281
#define FOREIGN 282
#define FILET 283
#define MUTEX 284
#define SEMAPHORE 285
#define CONTINUATION 286
#define THREAD 287
#define VOID 288
#define BOOL 289
#define FUNCTION 290
#define FUNC 291
#define EXCEPTION 292
#define RAISE 293
#define TYPEDEF 294
#define IMPORT 295
#define NEW 296
#define ANONINIT 297
#define NAMESPACE 298
#define PUBLIC 299
#define PROTECTED 300
#define EXTEND 301
#define WHILE 302
#define DO 303
#define FOR 304
#define SWITCH 305
#define BREAK 306
#define CONTINUE 307
#define RETURNTOK 308
#define FORK 309
#define CASE 310
#define DEFAULT 311
#define TWIXT 312
#define NAME 313
#define TYPENAME 314
#define NAMESPACENAME 315
#define COMMAND 316
#define NAMECOMMAND 317
#define TEN_NUM 318
#define OCTAL0_NUM 319
#define OCTAL_NUM 320
#define BINARY_NUM 321
#define HEX_NUM 322
#define TEN_FLOAT 323
#define OCTAL0_FLOAT 324
#define OCTAL_FLOAT 325
#define BINARY_FLOAT 326
#define HEX_FLOAT 327
#define CHAR_CONST 328
#define STRING_CONST 329
#define POLY_CONST 330
#define THREAD_CONST 331
#define COMMENT_CONST 332
#define VOIDVAL 333
#define BOOLVAL 334
#define DARROW 335
#define ISTYPE 336
#define HASMEMBER 337
#define POUND 338
#define COMMA 339
#define ASSIGN 340
#define ASSIGNPLUS 341
#define ASSIGNMINUS 342
#define ASSIGNTIMES 343
#define ASSIGNDIVIDE 344
#define ASSIGNDIV 345
#define ASSIGNMOD 346
#define ASSIGNPOW 347
#define ASSIGNSHIFTL 348
#define ASSIGNSHIFTR 349
#define ASSIGNLXOR 350
#define ASSIGNLAND 351
#define ASSIGNLOR 352
#define ASSIGNOR 353
#define ASSIGNAND 354
#define QUEST 355
#define COLON 356
#define OR 357
#define AND 358
#define LOR 359
#define LXOR 360
#define LAND 361
#define EQ 362
#define NE 363
#define LT 364
#define GT 365
#define LE 366
#define GE 367
#define SHIFTL 368
#define SHIFTR 369
#define PLUS 370
#define MINUS 371
#define TIMES 372
#define DIVIDE 373
#define DIV 374
#define POW 375
#define STARSTAR 376
#define POW2 377
#define POW3 378
#define UNIONCAST 379
#define UMINUS 380
#define BANG 381
#define FACT 382
#define LNOT 383
#define INC 384
#define DEC 385
#define STAR 386
#define AMPER 387
#define THREADID 388
#define OS 389
#define CS 390
#define DOT 391
#define ARROW 392
#define STAROS 393
#define CALL 394
#define OP 395
#define CP 396
#define POINTER 397
#define COLONCOLON 398
#define IF 399
#define TRY 400
#define NONL 401
#define ELSE 402
#define CATCH 403
#define NL 404
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,   96,   96,   99,   99,   99,  100,  101,   98,
  102,  103,  103,  104,  104,  105,  105,   97,   97,   97,
   97,   97,   97,   97,    3,    3,    5,    5,    4,    7,
    7,    7,    6,    6,   27,   27,    1,    1,    2,    2,
   28,   28,   60,   60,  106,  107,    8,  108,  109,   14,
   14,   17,   17,   15,   15,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,  111,   16,   16,   16,   16,   70,   70,   19,   19,
   18,   12,   12,   13,    9,    9,  112,   10,   20,   20,
  110,  110,  113,   81,   82,   82,   21,   22,   22,   23,
   23,   24,   25,   25,   26,   26,   37,   37,   33,   33,
   35,   35,   40,   40,   34,   34,   36,   43,   38,   39,
   39,   39,   41,   41,   41,   42,   42,   42,   46,   46,
   46,   46,   46,   46,   45,   45,   45,   45,   45,   45,
   47,   47,   47,   47,   47,   47,   44,   44,   51,   51,
   51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
   51,   48,   48,   49,   49,   50,   50,   52,   52,   53,
   53,   54,   54,   56,   56,   55,   55,   55,   55,   57,
   57,   58,   58,   59,   59,   61,   61,   62,   62,   63,
   63,   66,   64,   64,   65,   65,   67,   67,   68,   68,
   69,   69,   71,   71,   77,   77,   72,   72,   73,   73,
   75,   75,   76,   76,   11,  114,   11,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   79,
   79,   78,   78,   78,   78,   78,   78,   78,   78,   78,
   78,   78,   78,   78,   78,   78,   80,   80,   80,   80,
   80,   83,   83,   83,   84,   84,   29,   29,   30,   30,
   31,   32,   85,   85,   86,   86,   87,   87,   87,   88,
   89,   89,   90,   90,   91,   91,   92,   93,   93,   94,
   94,   94,   94,   95,   95,   95,   95,
};
static const YYINT yylen[] = {                            2,
    2,    0,    1,    3,    1,    1,    1,    0,    0,    0,
    0,    1,    0,    1,    0,    1,    0,    4,    6,    4,
    6,    6,    1,    1,    1,    0,    3,    1,    2,    1,
    1,    1,    3,    0,    2,    1,    2,    1,    1,    3,
    3,    2,    1,    1,    0,    0,    3,    2,    2,    2,
    0,    7,    9,    1,    1,    3,    9,   10,    9,    9,
   10,    2,    2,    3,    2,    1,    4,   10,    6,    6,
    7,    0,    9,    6,    2,   11,    3,    1,    1,    3,
    4,    2,    0,    7,    1,    1,    0,    2,    1,    4,
    1,    1,    0,    2,    1,    0,    3,    2,    0,    4,
    3,    3,    2,    0,    7,    3,    1,    0,    3,    1,
    3,    1,    1,    1,    4,    2,    1,    1,    4,    3,
    4,    4,    2,    2,    0,    4,    3,    2,    2,    4,
    4,    4,    4,    0,    2,    2,    2,    2,    2,    3,
    1,    4,    4,    4,    3,    1,    1,    0,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    3,    1,    3,    1,    3,    1,    4,
    0,    4,    0,    1,    0,    1,    1,    1,    1,    1,
    0,    1,    1,    1,    1,    3,    2,    3,    2,    2,
    1,    3,    2,    1,    3,    2,    2,    1,    1,    0,
    1,    0,    1,    2,    1,    3,    1,    0,    3,    1,
    1,    0,    3,    2,    3,    0,    2,    3,    7,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    3,    3,    3,    3,    3,    3,
    2,    2,    3,    3,    5,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    6,    8,    8,    8,    3,    6,    2,    1,
    3,    3,    4,    4,    4,    6,    6,    3,    3,    1,
    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    0,    5,    9,    2,    1,    3,    1,
    1,    0,    3,    1,    1,    1,    1,    2,    0,    4,
    3,    1,    3,    2,    1,    1,    4,    3,    1,    3,
    3,    4,    4,    1,    1,    1,    2,
};
static const YYINT yydefred[] = {                         2,
    0,   10,   24,   23,    1,    3,    0,    0,    0,    0,
    0,   66,    0,   45,    0,  176,  177,  178,  179,  149,
  150,  151,  152,  153,  161,  154,  155,  156,  157,  158,
  159,  160,    8,    0,  182,  183,  185,    8,    8,    8,
    8,    0,    0,    0,    0,    8,   43,   36,    0,    0,
    0,  258,  260,  259,  261,  262,  263,  265,  264,  266,
  267,  268,  269,  270,  271,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  280,    0,    8,
    8,  257,   55,   10,   54,   46,    9,  146,    0,   93,
   45,    0,    0,    0,    0,  141,    0,    0,    0,    0,
   38,    0,    0,    0,    0,    0,    6,    7,    5,    4,
    0,    0,    0,  307,  309,  308,  310,  311,  220,   48,
  279,  290,    0,    0,    0,   45,   45,   45,   45,   62,
   63,    0,    0,    0,    0,    0,  201,    0,    0,   45,
   42,   10,  207,    0,   10,    0,   25,    0,    0,    0,
  138,    0,  139,    0,    0,  136,    0,  137,    0,    0,
    0,    0,    0,  272,    0,    0,    0,    0,   45,    0,
    0,    9,   75,   35,    0,   37,    0,    0,    8,    0,
    0,  204,    0,   45,    0,    0,   12,  128,    0,    0,
  135,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    8,    8,    8,  174,    0,    8,   65,    0,    0,
    0,  306,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  241,  242,  228,  230,
  232,    0,    0,    0,    0,    0,    0,    0,   46,    0,
    0,    8,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  117,   64,    0,    0,    0,    0,
   34,   30,   32,   31,    0,    0,    0,    0,    0,    0,
    0,    0,  282,    0,    0,  281,    0,    0,   79,   83,
   20,   56,   41,   86,   46,   85,    0,   95,   94,    0,
    0,    0,  120,    0,    0,    0,  140,  277,  167,    0,
    0,    0,    0,    0,  187,    0,    0,    0,  129,  138,
  139,  136,  137,    0,    0,  127,    0,    0,    0,    0,
    0,   10,   18,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  288,  289,    0,    0,    0,
  211,    0,    0,    0,   47,   50,   45,    0,  142,    0,
  143,    0,  144,  122,    0,    0,    0,    0,    0,    0,
   14,    0,  209,    0,   27,   33,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   67,   89,
   88,    0,  119,    0,    0,  193,    0,  121,    0,    0,
  344,  346,  345,  124,  118,    0,    8,   93,    0,    0,
    0,    0,    0,  190,  186,  199,    0,  189,  145,   45,
  114,    0,    0,    0,    0,    0,    0,  126,   44,   72,
    0,    0,  284,  283,    0,  214,  285,   49,    0,    0,
    0,  109,    0,    0,    0,    0,    0,    0,    0,   21,
   22,    0,    0,   45,  164,   45,   45,  168,    0,   46,
    0,   80,    0,   82,    0,  197,    0,  196,  347,    0,
    0,    0,    0,    0,    0,  324,    0,  332,    0,  339,
  326,  115,    0,    0,  133,  130,  166,  131,  132,  188,
    0,    9,    0,  113,    0,    0,    9,    0,   19,    0,
  213,    0,  170,  172,   69,    0,    0,    0,    0,    0,
    0,  286,  287,    0,    0,    0,    0,  273,    0,   45,
    0,  195,    0,    0,  334,  336,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  192,   46,    0,    0,   46,
   70,  111,    9,   40,   74,    0,    0,   46,    0,   77,
   46,   46,    0,    0,    0,   46,  327,    0,   46,    0,
   46,  312,    0,    0,   90,    0,  341,  321,  322,    0,
    0,  333,    0,  323,    0,    0,  331,  330,    0,    0,
  338,  337,  219,    0,  217,   93,   71,    0,    0,    9,
   46,    9,    9,    0,    0,   46,    0,    0,  328,  276,
  274,  313,  275,    0,   93,    0,    0,    0,  343,  315,
    0,    0,    9,   46,    0,   57,    9,   59,   60,    0,
    0,   97,   98,   46,   53,    0,    0,  319,    9,   73,
    9,   45,    0,   46,    0,   58,    0,  101,    9,   46,
    0,  318,   46,   68,   61,    0,    0,  102,  103,  100,
   76,   84,  317,    0,    0,  106,  316,  107,    0,    0,
   46,  105,
};
static const YYINT yydgoto[] = {                          1,
   82,  447,  145,  146,  147,  148,  285,   83,  305,  306,
  557,  408,  484,  259,  260,   85,   86,   87,  300,  411,
  572,  616,  617,  634,  654,  655,   88,   89,  663,  589,
  590,  626,  268,  182,  443,  183,  679,   90,   91,  444,
  315,   92,  426,   93,  138,  191,   95,  321,  290,  323,
   96,  291,  264,  266,   97,  206,   98,   99,  100,  101,
  192,  327,  328,  310,  416,  428,  417,  438,  466,  467,
  261,  142,  143,  103,  370,  371,  104,  257,  121,  119,
  177,  309,  581,  421,  495,  496,  576,  422,  497,  498,
  545,  423,  499,  500,  501,    5,    6,    8,  110,  311,
  173,    7,  188,  392,  551,  120,  374,  105,  375,  106,
  518,  307,  178,  559,
};
static const YYINT yysindex[] = {                         0,
 -242,    0,    0,    0,    0,    0, 1203, -233, -198, -185,
 -123,    0,  327,    0,  327,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -200,    0,    0,    0,    0,    0,    0,
    0,  -69,   60, 5386, 6574,    0,    0,    0, -140, 6574,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -63,  -60, 6574, 6574, 6574,
 6574, 6574, 6574, 6574, 6574, 6574,  -18,    0, 5254,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  148,    0,
    0,  -87,   62,  -34,  -15,    0, 5088,  127,  142,   87,
    0, -218, 7042,   67, 1339,  122,    0,    0,    0,    0,
 5088, 5088,  128,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  132,   57, -165,    0,    0,    0,    0,    0,
    0, -185, -123,  152,  142,  205,    0,  -46, 2124,    0,
    0,    0,    0, 6638,    0,  136,    0,  159, 6574, 6574,
    0,  866,    0,  866,  866,    0,  866,    0,  866,  866,
  866,  866,  866,    0, 5914,   91,   16,   99,    0, 1475,
   94,    0,    0,    0,  107,    0,  243,  180,    0,  203,
  123,    0,  185,    0, 5088,  216,    0,    0, 6046, 3788,
    0,  -15, -140, 5088, 5088, 5088, 5088, 5088,   25,   94,
  167,    0,    0,    0,    0, 5088,    0,    0, 5386,  131,
 6574,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 6574, 6574, 6574, 6574,
 6574, 6574, 6574, 6574, 6574, 6574, 6574, 6574, 6574, 6574,
 6574, 6574, 6574, 6574, 6574, 6574,    0,    0,    0,    0,
    0, 6574,  225,  228, 6574, 6574, 6574, 6574,    0, 1339,
  277,    0,  128,  276,  128,  278,  206,  279,  155, 6574,
  156, 1339,  161,  166,    0,    0,  168,  295, 6574,  295,
    0,    0,    0,    0,  164, 6695, 6752, 6574,   14, -290,
  176, 6809,    0,  254,    0,    0,  182, 1339,    0,    0,
    0,    0,    0,    0,    0,    0,  308,    0,    0,  183,
 5088,  189,    0, 6178,  237,  192,    0,    0,    0,   68,
  198,  251, -172,  201,    0, -253,  207, -162,    0,    0,
    0,    0,    0,  -53,  107,    0,  281, 3999, -200,   94,
  153,    0,    0,  845, 6865, 2237, 2350, 2463, 2576, 2689,
  589,  589,  440,  440,  440,  440,  316,  316,  736,  736,
  845,  845,  845,  845,  211,    0,    0,  214, 2010,  209,
    0, 7042, 7042,  338,    0,    0,    0,  343,    0,  347,
    0,  128,    0,    0,  217, 5386,  314, 5386, 5386, 5386,
    0,  220,    0,  221,    0,    0, 5088,  307,  226,  261,
  227,  241, 6574,  242,  372, 5386,  375,  248,    0,    0,
    0,  300,    0,  339,  167,    0, -135,    0, 5518, 7042,
    0,    0,    0,    0,    0,  152,    0,    0,  -15,  -15,
  383,  -15,  -15,    0,    0,    0, 5088,    0,    0,    0,
    0,    0,  389,  317, -261,  319,  394,    0,    0,    0,
  258, 6574,    0,    0, 6574,    0,    0,    0,  273, 5088,
 5088,    0,  404,  274,  280,  406,  282,  284,  407,    0,
    0,  -37,  286,    0,    0,    0,    0,    0, 6574,    0,
  287,    0, -200,    0, 6574,    0, 5088,    0,    0,  334,
 6178,  -18,  363, 6926,  346,    0,  352,    0,  356,    0,
    0,    0,  303,    0,    0,    0,    0,    0,    0,    0,
  301,    0,  165,    0,  412, -200,    0,  436,    0, 2124,
    0, 5386,    0,    0,    0, 1339, 5386, 5386, 1339,  308,
 5386,    0,    0,  437,  443,  445,  866,    0, 1339,    0,
 1613,    0, 6178, 7042,    0,    0,  400,  374, 6178, 6178,
  446, 6310,  447, -216,  449,    0,    0,  380,  308,    0,
    0,    0,    0,    0,    0, 1339,  325,    0,  326,    0,
    0,    0,  100,  330, 5650,    0,    0, 6442,    0, 5782,
    0,    0,  321,  192,    0, 7042,    0,    0,    0,  408,
 6178,    0, 7042,    0,  460, 6926,    0,    0,  334,  363,
    0,    0,    0, 6574,    0,    0,    0,  465,  308,    0,
    0,    0,    0, 5386,  410,    0,  100, 1339,    0,    0,
    0,    0,    0, 1339,    0,  349,  400, 7042,    0,    0,
 7042,  534,    0,    0,  181,    0,    0,    0,    0,  444,
 1339,    0,    0,    0,    0,  308, -234,    0,    0,    0,
    0,    0,  448,    0,  181,    0, 1339,    0,    0,    0,
 6178,    0,    0,    0,    0,  488, 1339,    0,    0,    0,
    0,    0,    0,  539,  502,    0,    0,    0,  463, 1339,
    0,    0,
};
static const YYINT yyrindex[] = {                         0,
 1067,    0,    0,    0,    0,    0,  219,    0,    0,  515,
  517,    0,    0,    0, 1548,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   77,  532,    0,    0,    0, 1680, -252,
 -149,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  532,  532,  532,
  532,  532,  532,  532,  532,  532,    0,    0,  532,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   31,  328,    0, -267,  528,  891,    0,
    0,  424, -245, -235,   97,    0,    0,    0,    0,    0,
  -57,   17,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  931,    0,    0,  543, 5066,    0,
    0,    0,    0, -176,    0, -173,    0,    0,  532,  532,
    0, 2076,    0, 2190, 2304,    0, 2418,    0, 2532, 2646,
 2760, 2874, 2988,    0,  532,    0, -228,    0,    0,  219,
  765,    0,    0,    0, 1680,    0, -133,   15,    0,    0,
  -52,    0, -220,    0,    0,    0,    0,    0, -250,    0,
    0,  328,    0,    0,    0,    0,    0,    0,    0,   74,
 -265,    0,    0,    0,    0, -267,    0,    0,  532,    0,
  532,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  532,  532,  532,  532,
  532,  532,  532,  532,  532,  532,  532,  532,  532,  532,
  532,  532,  532,  532,  532,  532,    0,    0,    0,    0,
    0,  532,    0,    0,  532, -249,  532,  532,    0,  145,
    0,    0,    0,    0,    0,    0,  -38,    0,    0, -247,
    0,  219,    0,    0,    0,    0,    0,  432,  532,  432,
    0,    0,    0,    0, -244,    0,    0,  -85,  543,    0,
    0,  452,    0,    0,  240,    0,    0,   97,    0,    0,
    0,    0,    0,    0,    0,    0,  497,    0,    0,    0,
 -282,    0,    0,  532,  -55,    0,    0,    0,    0,  543,
    0,  453,    0,    0,    0,  -73,    0,  442,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   74,
    0,    0,    0, 3216,    0, 5043, 4949, 4924, 4828, 4800,
 4602, 4701, 4190, 4293, 4396, 4499, 3980, 4085, 3766, 3873,
 3326, 3436, 3546, 3656,    0,    0,    0,    0,  442,    0,
    0, -211,  -67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  532,    0, -181,  532,   77,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  532, 6985,    0,  532,    0,  469,    0,    0,
    0,    0,    0,    0, -171,    0,  442,    0,  532,   38,
    0,    0,    0,    0,    0,    0,    0,    0,  328,  328,
    0,  328,  328,    0,    0,    0,    0,    0,    0,    0,
    0,  163,    0,  579,    0,  581,    0,    0,    0,    0,
    0,  532,    0,    0,  532,    0,    0,    0,    0,  -57,
   17,    0,    0,    0,    0,  451,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  532,    0,
    0,    0,    0,    0,  532,    0,  535,    0,    0, 1876,
  532,  536, 1746,   30,  218,    0,  583,    0,  583,    0,
    0,    0,    0,  -72,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 5156,
    0,  532,    0,    0,    0,  219,  532, -181,  219,    0,
 -195,    0,    0, 1812,    0, 1944, 3102,    0,  219,    0,
    0,    0,  532, -139,    0,    0,    0,    0,  532,  105,
  588,  135,    0,  591,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   97,    0,    0,    0,    0,
    0,    0,  593,    0,  532,    0,    0,  532,    0,  532,
    0,    0,  614,    0,    0,   11,    0,    0,    0,  467,
  532,    0,   30,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  532,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  532,    0,    0,  593,  219,    0,    0,
    0,    0,    0,  219,    0,    0,    0,   24,    0,    0,
 -182,    0,    0,    0,  594,    0,    0,    0,    0,    0,
  145,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  594,    0,  145,    0,    0,    0,
  532,    0,    0,    0,    0,    0,  145,    0,    0,    0,
    0,    0,    0,    0,  507,    0,    0,    0,    0,  145,
    0,    0,
};
static const YYINT yygindex[] = {                         0,
  -19,  350,    0,    0,  584,    0,    0,  -78,    0,    0,
    0,    0,    0, -232,   -3,  697,    0,    0,    0,    0,
    0,  255,    0,    0,  222,    0,    0,  112,    0,  257,
    0,    0, -239,  466, -411,    0,    0,    0,    0,    0,
    0,  -28,    0,  -94,   -7, -156,    0,    0,  689,    0,
    0, -184,  450,  483,  212,    0,    0,   43,    0,  -82,
  434,  474,    0,  519,  462,  368,    0, -359,  -42,  441,
   12,  694,  692,    5,    0,  513,    0,    0,    0,  961,
 -420,    0,    0,   -8,    0, -538,    0,  454,    0,  425,
  430,    0,    0,  429, -279,    0,    0,  -75,    0,   92,
 -166,    0, -160,  707,    7,  187,   21, -508, -326,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 7437
static const YYINT yytable[] = {                         94,
  166,  136,  200,   84,  324,  302,  176,  504,  171,  456,
  301,  594,  208,    2,  124,  134,  263,  265,  102,  205,
   29,  573,  148,  378,  147,  380,  210,  376,    3,  203,
  148,  107,   14,  515,  424,  329,   94,  108,  148,  336,
  148,  148,  176,  148,  125,  148,  208,  147,  400,  139,
  134,  441,  514,  218,  144,  137,  218,  488,  218,  434,
  151,  153,  147,  156,  158,  407,  278,  365,  111,  280,
  368,  167,  152,  154,  155,  157,  159,  160,  161,  162,
  163,  112,  215,  202,   13,  215,  135,  215,  210,  201,
  168,   28,  205,  205,   29,  148,  599,   94,  198,  401,
  635,  562,  203,  201,  201,  661,  172,  436,  185,  148,
  205,  340,   47,  194,   49,   26,  185,  125,  125,  209,
  203,  135,  673,  218,  123,  480,  218,  218,  335,  126,
  127,  128,  129,   87,  436,  125,  148,  140,  147,  163,
  412,  147,  462,  113,  218,  125,  212,   47,  208,  175,
  205,  208,  215,  286,  287,  215,  215,  289,  205,   29,
  203,    4,   94,   34,   34,   34,  431,  198,  203,  292,
  109,  169,  170,  215,  600,  125,  437,  317,  218,  448,
  134,  320,  326,  125,  218,  632,  330,  331,  332,  333,
  334,  595,  218,  292,  216,  130,  191,  206,  201,  335,
  202,   94,  180,  487,  646,  148,   87,  215,  199,  116,
  171,  546,  117,  215,  202,  344,  414,  432,  478,  210,
  342,  215,  199,  199,  198,  181,  110,  210,  410,  110,
   28,  345,  346,  347,  348,  349,  350,  351,  352,  353,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  135,   94,  165,   26,  148,  292,  141,  450,  292,
  369,  372,  373,  587,   94,  191,  451,    9,  387,  546,
  206,  206,  505,  506,  144,  508,  509,  179,  340,   96,
  156,   96,  116,  144,  173,  117,  117,  117,  206,  642,
   94,  342,  157,  337,  338,  339,  199,  325,  341,  325,
  116,  199,  123,  415,  165,  199,  199,  199,  199,  199,
  205,  629,  271,  272,  273,  274,  185,  199,  420,  446,
   13,  147,  191,  185,  131,  409,  277,  668,  206,  148,
  445,  149,  185,  608,  150,  185,  206,  558,  174,  335,
  116,  202,  439,   13,  186,  561,  205,  469,  116,  340,
  565,  117,  184,  377,   96,  297,  186,  134,  532,  134,
  134,  134,  342,   13,   51,  263,  265,  148,  325,  187,
  316,  164,   16,  189,   16,  123,  123,  134,   94,  190,
   94,   94,   94,  185,  207,  185,   13,  148,  181,  472,
  181,  181,  414,  123,  181,  148,  607,  464,   94,  137,
  468,  137,   16,  399,  186,  258,  294,  292,  658,  614,
  615,  295,   51,   16,   17,   18,   19,  481,  202,  187,
  203,  204,  199,  494,  670,  148,  262,  113,  135,  326,
  135,  135,  135,  123,  676,  148,  181,  185,  181,  181,
  267,  123,  181,  636,  269,  638,  639,  681,  135,  199,
  125,  270,  201,  201,   51,   51,  520,  429,  186,  369,
   47,  174,  175,  540,  275,   47,  650,  449,   81,  276,
  656,  282,  283,  284,  281,   36,   36,  441,  514,  415,
  605,  405,  664,  537,  665,   17,  293,   17,  574,  541,
  652,  653,  671,  134,  296,  544,  446,  187,  134,  134,
  538,  113,  134,  553,  303,  555,   45,  304,  199,  148,
  181,  308,  181,  181,   94,  312,  181,  313,   94,   94,
   94,   94,  568,   94,  314,  571,  579,  582,  318,  145,
  145,   94,   36,  567,  343,  583,  185,  366,  569,  137,
  367,  208,  137,  379,  382,  381,  383,  586,  199,  384,
  386,   36,  145,  544,  593,  388,  596,   36,   94,  391,
  389,  396,  390,  459,  135,  402,  404,  660,  662,  135,
  135,  199,  199,  135,   14,  425,  406,  603,  413,  596,
  606,  211,  593,  418,  593,  134,  427,  430,  610,  400,
  433,  612,  613,  440,  125,  628,  620,  134,  199,  621,
  453,  623,  435,  454,  457,  458,   94,  460,  631,  145,
   94,  461,  463,   52,  644,  465,   94,  134,  134,  473,
  645,  474,  476,  470,  471,  640,  511,  125,  145,  145,
  145,  637,  475,   94,  145,  145,  477,  479,  419,  485,
  134,  134,  482,  145,  114,  115,  116,  117,  118,   94,
  483,  486,  507,  512,  651,  513,  135,  516,  517,   94,
  534,  519,  535,  536,  659,  593,  134,  522,  525,  526,
  528,  531,   94,  543,  527,  548,  563,  529,  547,  530,
  672,  533,  539,  674,  550,  241,  242,  243,  244,  245,
  552,  246,  247,  248,  554,  190,  249,  134,  556,  250,
  251,  682,  566,  575,  252,  211,  253,  254,  255,  578,
  256,  580,  588,  591,  598,  436,  602,  134,  134,  604,
  609,  611,  624,  134,   81,  618,  584,  630,   81,   81,
   81,  134,  633,   81,   81,   81,   81,   81,  647,   81,
   81,   81,   81,   81,   81,   81,  627,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   13,  641,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,  649,  657,
  675,   81,   81,  667,   81,   81,  677,  239,  240,  241,
  242,  243,  244,  245,  678,  246,  247,  248,  680,   91,
  249,   92,  148,  250,  251,  184,   81,   10,  252,   81,
  253,  254,  255,  147,  256,   15,    9,  200,  666,   81,
   81,  169,  162,  112,   81,   39,   78,  148,   45,   81,
   17,   81,   81,   81,  211,  200,  320,   81,   16,   81,
   99,  104,  108,   81,  395,  564,  299,   81,   81,   52,
   81,  643,   81,   52,   52,   52,  669,  322,   52,   52,
   52,   52,   52,  648,   52,   52,   52,   52,   52,   52,
   52,  502,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,  523,
  510,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,  524,  560,  503,   52,   52,  542,   52,
   52,  625,  235,  236,  237,  238,  239,  240,  241,  242,
  243,  244,  245,  385,  246,  247,  248,  521,  570,  249,
  393,   52,  250,  251,   52,  122,  597,  252,  592,  253,
  254,  255,  601,  256,   52,   52,  394,  577,    0,   52,
    0,    0,    0,    0,   52,    0,   52,   52,   52,    0,
    0,  211,   52,    0,   52,    0,    0,    0,   52,    0,
    0,    0,   52,   52,    0,    0,   52,   52,    0,    0,
   13,    0,    0,    0,   13,   13,   13,    0,    0,   13,
   13,   13,    0,   13,    0,   13,   13,   13,   13,   13,
   13,   13,    0,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
    0,    0,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,    0,    0,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,    0,    0,    0,   13,   13,    0,
   13,   13,    0,    0,    0,    0,    0,  243,  244,  245,
    0,  246,  247,  248,    0,    0,  249,    0,    0,  250,
  251,    0,   13,    0,  252,   13,  253,  254,  255,    0,
  256,    0,    0,    0,    0,   13,   13,    0,    0,    0,
   13,    0,    0,    0,    0,   13,    0,   13,   13,   13,
  175,  175,  175,   13,    0,   13,    0,    0,    0,   13,
    0,    0,    0,   13,   13,    0,  175,  175,    0,  175,
  175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
  175,    0,  180,    0,  180,  180,    0,    0,  180,    0,
  175,  175,  175,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  175,  175,  175,  175,  175,    0,  175,
  175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
  246,  247,  248,    0,    0,  249,    0,    0,  250,  251,
    0,    0,    0,  252,    0,  253,  254,  255,    0,  256,
    0,    0,    0,  175,  175,  175,  249,    0,  175,  250,
  251,  175,    0,    0,  252,    0,  253,  254,  255,    0,
  256,    0,  175,    0,    0,    0,  175,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  175,    0,    0,  175,    0,
    0,  175,    0,    0,  175,    0,    0,    0,    0,    0,
    0,    0,  175,    0,    0,    0,  175,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  175,   11,   11,   11,    0,
    0,   11,   11,   11,  175,   11,    0,    0,   11,   11,
   11,   11,   11,   11,    0,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,    0,    0,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,    0,    0,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,    0,    0,    0,   11,
   11,    0,   11,   11,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   11,    0,    0,   11,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   11,   11,    0,
    0,    0,   11,    0,    0,    0,    0,   11,    0,   11,
   11,   11,    0,    0,    0,   11,    0,   11,    0,    0,
    0,   11,    9,   10,   11,   11,   11,   12,   13,   14,
    0,   15,    0,    0,   16,   17,   18,   19,   20,   21,
    0,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,    0,    0,   34,    0,    0,    0,    0,
    0,   35,   36,   37,   38,   39,   40,   41,   42,   43,
   44,   45,    0,    0,   46,   47,   48,   49,   50,   51,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,    0,   64,   65,    0,   66,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   68,    0,    0,   69,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   70,   71,    0,    0,    0,   72,    0,
    0,    0,    0,   73,    0,   74,   75,   76,    0,    0,
    0,   77,    0,   78,    0,    0,    0,   79,    9,   10,
   11,   80,   81,   12,   13,   14,    0,   15,    0,    0,
   16,   17,   18,   19,   20,   21,    0,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,   33,    0,
    0,   34,    0,    0,    0,    0,    0,   35,   36,   37,
   38,   39,   40,   41,   42,   43,   44,   45,    0,    0,
   46,   47,   48,   49,    0,    0,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,    0,    0,
    0,   64,   65,    0,   66,   67,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   68,    0,    0,   69,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   70,
   71,    0,    0,    0,   72,    0,    0,    0,    0,   73,
    0,   74,   75,   76,    0,    0,    0,   77,    0,   78,
    0,    0,    0,   79,    9,   10,   11,   80,   81,   12,
   13,  298,    0,   15,    0,    0,   16,   17,   18,   19,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,   33,    0,    0,   34,    0,    0,
    0,    0,    0,   35,   36,   37,   38,   39,   40,   41,
   42,   43,   44,   45,    0,    0,   46,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,    0,   64,   65,    0,
   66,   67,  291,  291,    0,  291,    0,  291,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   68,    0,    0,   69,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   70,   71,    0,    0,    0,
   72,    0,    0,    0,    0,   73,    0,   74,   75,   76,
    0,    0,    0,   77,    0,   78,    0,    0,    0,   79,
    0,    0,    0,   80,   81,    0,    0,  585,  211,    0,
    0,    0,  291,    0,    0,  291,  291,  291,  291,  291,
  291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
  291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
  291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
  291,  291,    0,  291,  291,  291,    0,    0,  291,    0,
    0,  291,  291,    0,    0,    0,  291,  291,  291,  291,
  291,    0,  291,  291,   44,   44,    0,   44,    0,   44,
    0,  291,  212,  213,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,    0,  228,
  229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
  239,  240,  241,  242,  243,  244,  245,    0,  246,  247,
  248,    0,    0,  249,    0,    0,  250,  251,    0,    0,
    0,  252,    0,  253,  254,  255,    0,  256,    0,    0,
    0,  280,    0,  280,   44,  280,    0,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,    0,   44,   44,   44,    0,    0,
   44,    0,    0,   44,   44,    0,    0,    0,   44,   44,
   44,   44,   44,    0,   44,   44,  329,  329,    0,  329,
  280,  329,    0,   44,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
  280,    0,  280,  280,  280,  280,  280,  280,  280,  280,
  280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
    0,  280,  280,  280,    0,    0,  280,    0,    0,  280,
  280,    0,    0,    0,  280,    0,  280,  280,  280,    0,
  280,   43,    0,   43,    0,   43,  329,    0,    0,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,    0,  329,  329,  329,
    0,    0,  329,    0,    0,  329,  329,    0,    0,    0,
  329,  329,  329,  329,  329,    0,  329,  329,  314,  314,
   43,  314,    0,  314,   43,  329,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,    0,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
    0,   43,   43,   43,    0,    0,   43,    0,    0,   43,
   43,    0,    0,    0,   43,    0,   43,   43,   43,    0,
   43,    0,    0,    0,    0,  211,    0,    0,  314,  436,
    0,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
  314,  314,  314,  314,  314,  314,  314,  314,    0,  314,
  314,  314,    0,    0,  314,    0,    0,  314,  314,    0,
    0,    0,  314,  314,  314,  314,  314,    0,  314,  314,
  224,  224,    0,  224,    0,  224,    0,  314,  455,  212,
  213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  226,  227,    0,  228,  229,  230,  231,
  232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
  242,  243,  244,  245,    0,  246,  247,  248,    0,  211,
  249,    0,    0,  250,  251,    0,    0,    0,  252,    0,
  253,  254,  255,    0,  256,    0,    0,    0,    0,    0,
  224,    0,    0,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
    0,  224,  224,  224,  223,  223,    0,  223,    0,  223,
    0,    0,    0,    0,    0,  224,    0,    0,    0,    0,
    0,  224,    0,    0,    0,    0,    0,    0,  227,  224,
  228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
  238,  239,  240,  241,  242,  243,  244,  245,    0,  246,
  247,  248,  211,    0,  249,    0,    0,  250,  251,    0,
    0,    0,  252,    0,  253,  254,  255,    0,  256,    0,
    0,    0,    0,    0,  223,    0,    0,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,    0,  223,  223,  223,  225,  225,
    0,  225,    0,  225,    0,    0,    0,    0,    0,  223,
    0,    0,    0,    0,    0,  223,    0,    0,    0,    0,
    0,    0,    0,  223,  229,  230,  231,  232,  233,  234,
  235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
  245,    0,  246,  247,  248,  211,    0,  249,    0,    0,
  250,  251,    0,    0,    0,  252,    0,  253,  254,  255,
    0,  256,    0,    0,    0,    0,    0,    0,  225,    0,
    0,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,    0,  225,
  225,  225,  221,  221,    0,  221,    0,  221,    0,    0,
    0,    0,    0,  225,    0,    0,    0,    0,    0,  225,
    0,    0,    0,    0,    0,    0,    0,  225,  230,  231,
  232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
  242,  243,  244,  245,    0,  246,  247,  248,  211,    0,
  249,    0,    0,  250,  251,    0,    0,    0,  252,    0,
  253,  254,  255,    0,  256,    0,    0,    0,    0,    0,
    0,    0,  221,    0,    0,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,    0,  221,  221,  221,  222,  222,    0,  222,
    0,  222,    0,    0,    0,    0,    0,  221,    0,    0,
    0,    0,    0,  221,    0,    0,    0,    0,    0,    0,
    0,  221,  231,  232,  233,  234,  235,  236,  237,  238,
  239,  240,  241,  242,  243,  244,  245,    0,  246,  247,
  248,  211,    0,  249,    0,    0,  250,  251,    0,    0,
    0,  252,    0,  253,  254,  255,    0,  256,    0,    0,
    0,    0,    0,    0,    0,    0,  222,    0,    0,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,    0,  222,  222,  222,
  227,  227,    0,  227,    0,  227,    0,    0,    0,    0,
    0,  222,    0,    0,    0,    0,    0,  222,    0,    0,
    0,    0,    0,    0,    0,  222,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
    0,  246,  247,  248,  211,    0,  249,    0,    0,  250,
  251,    0,    0,    0,  252,    0,  253,  254,  255,    0,
  256,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  227,    0,    0,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
  227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
    0,  227,  227,  227,  226,  226,    0,  226,    0,  226,
    0,    0,    0,    0,    0,  227,    0,    0,    0,    0,
    0,  227,    0,    0,    0,    0,    0,    0,    0,  227,
  233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
  243,  244,  245,    0,  246,  247,  248,    0,    0,  249,
    0,    0,  250,  251,    0,    0,    0,  252,    0,  253,
  254,  255,    0,  256,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  226,    0,    0,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,    0,  226,  226,  226,  229,  229,
    0,  229,    0,  229,    0,    0,    0,    0,    0,  226,
    0,    0,    0,    0,    0,  226,    0,    0,    0,    0,
    0,    0,    0,  226,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  229,    0,
    0,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,  229,  229,
  229,  229,  229,  229,  229,  229,  229,  229,    0,  229,
  229,  229,  231,  231,    0,  231,    0,  231,    0,    0,
    0,    0,    0,  229,    0,    0,    0,    0,    0,  229,
    0,    0,    0,    0,    0,    0,    0,  229,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  231,    0,    0,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,    0,  231,  231,  231,  278,  278,    0,  278,
    0,  278,    0,    0,    0,    0,    0,  231,    0,    0,
    0,    0,    0,  231,    0,    0,    0,    0,    0,    0,
    0,  231,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  278,    0,    0,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,  278,  278,  278,  278,
  278,  278,  278,  278,  278,  278,    0,  278,  278,  278,
  239,  239,    0,  239,    0,  239,    0,    0,    0,    0,
    0,  278,    0,    0,    0,    0,    0,  278,    0,    0,
    0,    0,    0,    0,    0,  278,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  239,    0,    0,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  236,  236,    0,  236,    0,  236,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  239,    0,    0,    0,    0,
    0,  239,    0,    0,    0,    0,    0,    0,    0,  239,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  236,    0,    0,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  237,  237,    0,  237,    0,  237,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  236,    0,    0,    0,    0,
    0,  236,    0,    0,    0,    0,    0,    0,    0,  236,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  237,    0,    0,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  238,  238,    0,  238,    0,  238,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  237,    0,    0,    0,    0,
    0,  237,    0,    0,    0,    0,    0,    0,    0,  237,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  238,    0,    0,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  240,  240,    0,  240,    0,  240,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  238,    0,    0,    0,    0,
    0,  238,    0,    0,    0,    0,    0,    0,    0,  238,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  240,    0,    0,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  234,    0,    0,  234,    0,  234,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  240,    0,    9,  132,  133,
    0,  240,    0,    0,    0,    0,    0,    0,    0,  240,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  234,   48,  193,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  235,    0,    0,
  235,    0,  235,    0,    0,  194,    0,    0,  195,    0,
    0,    0,    0,    0,    0,  234,    0,    0,    0,  196,
    0,  234,    0,  197,    0,    0,    0,    0,    0,  234,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  198,  325,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  235,    0,    0,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  243,    0,    0,  243,    0,  243,
    0,    0,    0,    0,    0,    0,    0,    0,    9,  132,
  133,    0,  235,    0,    0,    0,    0,    0,  235,    0,
    0,    0,    0,    0,   20,   21,  235,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  441,  442,  193,  243,    0,    0,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  244,
    0,    0,  244,    0,  244,    0,  194,    0,    0,  195,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  243,
  196,    0,    0,    0,  197,  243,    0,    0,    0,    0,
    0,    0,    0,  243,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  198,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  244,
    0,    0,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  253,    0,    0,  253,    0,  253,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  244,    0,    0,    0,    0,    0,
  244,    0,    0,    0,    0,    0,    0,    0,  244,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  253,    0,    0,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  254,    0,    0,
  254,    0,  254,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  253,
    0,    0,    0,    0,    0,  253,    0,    0,    0,    0,
    0,    0,    0,  253,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  254,    0,    0,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  255,    0,    0,  255,    0,  255,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  254,    0,    0,    0,    0,    0,  254,    0,
    0,    0,    0,    0,    0,    0,  254,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  255,    0,    0,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  256,    0,    0,  256,    0,  256,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  255,    0,    0,    0,    0,
    0,  255,    0,    0,    0,    0,    0,    0,    0,  255,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  256,    0,    0,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  251,    0,    0,  251,
    0,  251,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  256,    0,
    0,    0,    0,    0,  256,    0,    0,    0,    0,    0,
    0,    0,  256,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  251,    0,    0,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  252,    0,    0,  252,    0,
  252,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  251,    0,    0,    0,    0,    0,  251,    0,    0,
    0,    0,    0,    0,    0,  251,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  252,    0,    0,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  247,    0,    0,  247,    0,  247,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  252,    0,  246,    0,    0,  246,  252,  246,    0,    0,
    0,    0,    0,    0,  252,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  247,    0,    0,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,    0,  246,    0,    0,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  248,  247,
    0,  248,    0,  248,    0,  247,    0,    0,    0,    0,
    0,    0,    0,  247,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  249,    0,    0,  249,  246,  249,    0,
    0,    0,    0,  246,    0,    0,    0,    0,    0,    0,
    0,  246,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  248,    0,
    0,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  249,    0,    0,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  250,    0,    0,
  250,    0,  250,  248,    0,    0,    0,    0,    0,  248,
    0,    0,    0,    0,    0,    0,    0,  248,    0,    0,
  233,    0,    0,  233,    0,  233,    0,    0,  249,    0,
    0,    0,    0,    0,  249,    0,    0,    9,  132,  133,
    0,    0,  249,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,  250,    0,    0,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  233,   48,  193,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  245,  233,    0,  245,    0,  245,    0,    0,    0,    0,
    0,    0,  250,    0,    0,    0,    0,    0,  250,    0,
    0,    0,    0,    0,    0,  194,  250,    0,  195,    0,
    0,    0,    0,    0,    0,  233,    0,    0,    0,  196,
    0,  233,    0,  197,    0,    0,    0,    0,    0,  233,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  198,    0,    0,    0,    0,    0,    0,    0,
  245,    0,    0,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
    0,  245,    0,    9,  132,  133,    0,    0,    0,   13,
   14,    0,   15,    0,    0,   16,   17,   18,   19,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,  245,    0,    0,    0,    0,
    0,  245,   35,   36,    0,    0,    0,    0,    0,  245,
    0,    0,   45,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,    0,   64,   65,    0,   66,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,    0,    0,   69,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   70,   71,    0,    0,    0,   72,
    0,    0,    0,    0,   73,    0,   74,   75,   76,    0,
    0,    0,  165,    0,   78,    9,  132,  133,   79,    0,
    0,   13,    0,    0,   15,    0,    0,   16,   17,   18,
   19,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   35,   36,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,    0,   47,   48,
   49,    0,    0,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,    0,   64,   65,
    0,   66,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,    0,    0,   69,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   70,   71,    0,    0,
    0,   72,    0,    0,    0,    0,   73,    0,   74,   75,
   76,    0,    0,    0,   77,    0,   78,    9,  132,  133,
   79,    0,    0,   13,  419,  489,   15,    0,    0,    0,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
  490,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,    0,
   64,   65,  491,   66,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   68,    0,    0,   69,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   70,   71,
    0,    0,    0,   72,    0,    0,    0,    0,   73,    0,
   74,   75,   76,    0,    0,    0,  492,    0,  493,    9,
  132,  133,   79,    0,    0,   13,    0,  619,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,  491,   66,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,    0,    0,
   69,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   70,   71,    0,    0,    0,   72,    0,    0,    0,    0,
   73,    0,   74,   75,   76,    0,    0,    0,   77,    0,
   78,    9,  132,  133,   79,    0,    0,   13,  419,  622,
   15,    0,    0,    0,    0,    0,    0,   20,   21,    0,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   45,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,    0,   66,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
    0,    0,   69,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   70,   71,    0,    0,    0,   72,    0,    0,
    0,    0,   73,    0,   74,   75,   76,    0,    0,    0,
  492,    0,   78,    9,  132,  133,   79,    0,    0,   13,
    0,    0,   15,    0,    0,    0,    0,    0,    0,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   45,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,    0,   64,   65,    0,   66,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,    0,    0,   69,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   70,  288,    0,    0,    0,   72,
    0,    0,    0,    0,   73,    0,   74,   75,   76,    0,
    0,    0,   77,  164,   78,    9,  132,  133,   79,    0,
    0,   13,    0,    0,   15,  319,    0,    0,    0,    0,
    0,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,    0,   47,   48,
   49,    0,    0,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,    0,   64,   65,
    0,   66,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,    0,    0,   69,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   70,  288,    0,    0,
    0,   72,    0,    0,    0,    0,   73,    0,   74,   75,
   76,    0,    0,    0,   77,    0,   78,    9,  132,  133,
   79,    0,    0,   13,  419,    0,   15,    0,    0,    0,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
   47,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,    0,
   64,   65,    0,   66,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   68,    0,    0,   69,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   70,   71,
    0,    0,    0,   72,    0,    0,    0,    0,   73,    0,
   74,   75,   76,    0,    0,    0,   77,    0,   78,    9,
  132,  133,   79,    0,    0,   13,    0,    0,   15,    0,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,  491,   66,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,    0,    0,
   69,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   70,   71,    0,    0,    0,   72,    0,    0,    0,    0,
   73,    0,   74,   75,   76,    0,    0,    0,   77,    0,
   78,    9,  132,  133,   79,    0,    0,   13,  419,    0,
   15,    0,    0,    0,    0,    0,    0,   20,   21,    0,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   45,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,    0,   66,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
    0,    0,   69,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   70,   71,    0,    0,    0,   72,    0,    0,
    0,    0,   73,    0,   74,   75,   76,    0,    0,    0,
  492,    0,   78,    9,  132,  133,   79,    0,    0,   13,
    0,    0,   15,    0,    0,    0,    0,    0,    0,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   45,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,  211,    0,    0,   64,   65,    0,   66,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,    0,    0,   69,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   70,   71,    0,    0,    0,   72,
    0,    0,    0,    0,   73,    0,   74,   75,   76,    0,
  211,    0,   77,    0,   78,    0,    0,    0,   79,    0,
    0,    0,    0,    0,    0,    0,  279,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,  226,  227,    0,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
  244,  245,    0,  246,  247,  248,    0,  211,  249,    0,
    0,  250,  251,    0,    0,    0,  252,    0,  253,  254,
  255,    0,  256,  397,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
    0,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,  239,  240,  241,  242,  243,  244,  245,    0,
  246,  247,  248,    0,  211,  249,    0,    0,  250,  251,
    0,    0,    0,  252,    0,  253,  254,  255,    0,  256,
  398,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,    0,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
  240,  241,  242,  243,  244,  245,    0,  246,  247,  248,
  211,    0,  249,    0,    0,  250,  251,    0,    0,    0,
  252,    0,  253,  254,  255,    0,  256,  403,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,    0,  228,  229,  230,  231,  232,
  233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
  243,  244,  245,    0,  246,  247,  248,    0,    0,  249,
    0,  211,  250,  251,    0,    0,    0,  252,    0,  253,
  254,  255,    0,  256,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  452,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,  239,  240,  241,  242,  243,  244,  245,    0,
  246,  247,  248,    0,    0,  249,    0,    0,  250,  251,
  277,    0,    0,  252,    0,  253,  254,  255,    0,  256,
  549,    0,    0,    0,    0,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
  227,    0,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
    0,  246,  247,  248,    0,    0,  249,  211,    0,  250,
  251,    0,    0,    0,  252,    0,  253,  254,  255,    0,
  256,    0,    0,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
    0,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,    0,
  277,  277,  277,    0,    0,  277,    0,    0,  277,  277,
    0,    0,    0,  277,    0,  277,  277,  277,    0,  277,
    0,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,    0,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
  240,  241,  242,  243,  244,  245,    0,  246,  247,  248,
    0,    0,  249,    0,    0,  250,  251,    0,    0,    0,
  252,    0,  253,  254,  255,    0,  256,
};
static const YYINT yycheck[] = {                          7,
   79,   44,   97,    7,  189,  172,   89,  428,   84,  369,
  171,  550,  265,  256,   34,   44,  111,  112,    7,  265,
  265,  530,  290,  263,  290,  265,  102,  260,  271,  265,
  313,  265,  267,  445,  314,  192,   44,  271,  291,  200,
  291,  291,  125,  291,  265,  313,  265,  313,  339,   45,
   79,  313,  314,  265,   50,   44,  268,  417,  270,  313,
   68,   69,  291,   71,   72,  298,  142,  252,  267,  145,
  255,   79,   68,   69,   70,   71,   72,   73,   74,   75,
   76,  267,  265,  265,  313,  268,   44,  270,  265,   97,
   79,  265,  338,  339,  339,  291,  313,  105,  270,  390,
  609,  513,  338,  111,  112,  340,   86,  270,  370,  291,
  356,  206,  313,  396,  315,  265,  370,  338,  339,  338,
  356,   79,  661,  335,   33,  405,  338,  339,  268,   38,
   39,   40,   41,  267,  270,  356,  404,   46,  404,  390,
  307,  313,  382,  267,  356,   34,  396,  313,  396,  315,
  396,  404,  335,  149,  150,  338,  339,  165,  404,  404,
  396,  404,  170,  313,  314,  315,  339,  339,  404,  165,
  404,   80,   81,  356,  391,  396,  339,  185,  390,  340,
  209,  189,  190,  404,  396,  606,  194,  195,  196,  197,
  198,  551,  404,  189,  267,  265,  270,  265,  206,  339,
  396,  209,  290,  339,  625,  291,  340,  390,   97,  265,
  268,  491,  265,  396,  396,  211,  311,  390,  403,  396,
  209,  404,  111,  112,  396,  313,  265,  404,  307,  268,
  404,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
  246,  209,  260,  339,  404,  313,  252,  398,  341,  255,
  256,  257,  258,  543,  272,  339,  342,  340,  272,  549,
  338,  339,  429,  430,  270,  432,  433,   91,  268,  265,
  288,  267,  338,  279,  268,  338,  339,  340,  356,  616,
  298,  268,  288,  202,  203,  204,  185,  268,  207,  270,
  356,  190,  265,  311,  390,  194,  195,  196,  197,  198,
   99,  591,  126,  127,  128,  129,  370,  206,  314,  339,
  290,  291,  396,  370,  265,  305,  140,  654,  396,  313,
  338,  395,  370,  566,  395,  370,  404,  504,  314,  315,
  396,  265,  396,  313,  391,  512,  135,  390,  404,  339,
  517,  404,  291,  262,  340,  169,  391,  386,  396,  388,
  389,  390,  339,  290,  268,  460,  461,  291,  339,  404,
  184,  390,  268,  389,  270,  338,  339,  406,  386,  395,
  388,  389,  390,  370,  298,  370,  313,  291,  292,  397,
  294,  295,  487,  356,  298,  291,  563,  386,  406,  388,
  389,  390,  268,  390,  391,  339,  391,  403,  641,  310,
  311,  396,  268,  272,  273,  274,  275,  406,  292,  404,
  294,  295,  311,  419,  657,  291,  305,  265,  386,  437,
  388,  389,  390,  396,  667,  291,  292,  370,  294,  295,
  313,  404,  298,  610,  313,  612,  613,  680,  406,  338,
  339,  395,  460,  461,  310,  311,  452,  390,  391,  455,
  313,  314,  315,  483,  313,  313,  633,  315,    0,  265,
  637,  313,  314,  315,  339,  313,  314,  313,  314,  487,
  559,  295,  649,  479,  651,  268,  396,  270,  531,  485,
  310,  311,  659,  522,  396,  491,  516,  404,  527,  528,
  480,  339,  531,  497,  398,  499,  267,  265,  397,  291,
  292,  332,  294,  295,  522,  313,  298,  395,  526,  527,
  528,  529,  526,  531,  340,  529,  535,  536,  313,  290,
  291,  539,  370,  522,  404,  539,  370,  313,  527,  528,
  313,  265,  531,  268,  339,  268,  268,  543,  437,  395,
  395,  389,  313,  549,  550,  395,  552,  395,  566,  265,
  395,  398,  395,  377,  522,  390,  313,  646,  647,  527,
  528,  460,  461,  531,  267,  339,  395,  557,  396,  575,
  560,  266,  578,  395,  580,  614,  395,  390,  568,  339,
  390,  571,  572,  313,  483,  591,  576,  270,  487,  579,
  390,  581,  396,  390,  396,  268,  614,  265,  604,  370,
  618,  265,  396,    0,  618,  302,  624,  290,  291,  313,
  624,  396,  396,  404,  404,  614,  440,  516,  389,  390,
  391,  611,  372,  641,  395,  396,  396,  396,  267,  340,
  313,  314,  268,  404,  318,  319,  320,  321,  322,  657,
  403,  313,  270,  265,  634,  339,  614,  339,  265,  667,
  474,  404,  476,  477,  644,  661,  339,  395,  265,  396,
  265,  265,  680,  340,  395,  313,  265,  396,  492,  396,
  660,  396,  396,  663,  339,  370,  371,  372,  373,  374,
  339,  376,  377,  378,  339,  395,  381,  370,  396,  384,
  385,  681,  267,  267,  389,  266,  391,  392,  393,  267,
  395,  267,  313,  340,  268,  270,  268,  390,  391,  340,
  396,  396,  402,  396,  256,  396,  540,  268,  260,  261,
  262,  404,  268,  265,  266,  267,  268,  269,  390,  271,
  272,  273,  274,  275,  276,  277,  339,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,    0,  356,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  265,  356,
  313,  333,  334,  356,  336,  337,  268,  368,  369,  370,
  371,  372,  373,  374,  313,  376,  377,  378,  356,  305,
  381,  305,  291,  384,  385,  298,  358,  404,  389,  361,
  391,  392,  393,  291,  395,  404,  340,  396,  652,  371,
  372,  390,  390,  265,  376,  265,  396,  313,  313,  381,
  268,  383,  384,  385,  266,  268,  390,  389,  268,  391,
  268,  268,  356,  395,  281,  516,  170,  399,  400,  256,
  402,  617,  404,  260,  261,  262,  655,  189,  265,  266,
  267,  268,  269,  627,  271,  272,  273,  274,  275,  276,
  277,  426,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  460,
  437,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  461,  511,  427,  333,  334,  487,  336,
  337,  584,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,  270,  376,  377,  378,  455,  528,  381,
  279,  358,  384,  385,  361,   15,  552,  389,  549,  391,
  392,  393,  554,  395,  371,  372,  280,  534,   -1,  376,
   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,
   -1,  266,  389,   -1,  391,   -1,   -1,   -1,  395,   -1,
   -1,   -1,  399,  400,   -1,   -1,  403,  404,   -1,   -1,
  256,   -1,   -1,   -1,  260,  261,  262,   -1,   -1,  265,
  266,  267,   -1,  269,   -1,  271,  272,  273,  274,  275,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
   -1,   -1,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,   -1,   -1,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,
  336,  337,   -1,   -1,   -1,   -1,   -1,  372,  373,  374,
   -1,  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,
  385,   -1,  358,   -1,  389,  361,  391,  392,  393,   -1,
  395,   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,
  376,   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,
  260,  261,  262,  389,   -1,  391,   -1,   -1,   -1,  395,
   -1,   -1,   -1,  399,  400,   -1,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,   -1,  292,   -1,  294,  295,   -1,   -1,  298,   -1,
  260,  261,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  313,  314,  315,  276,  277,   -1,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,  385,
   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,
   -1,   -1,   -1,  313,  314,  315,  381,   -1,  358,  384,
  385,  361,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,   -1,  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  395,   -1,   -1,  358,   -1,
   -1,  361,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  395,  260,  261,  262,   -1,
   -1,  265,  266,  267,  404,  269,   -1,   -1,  272,  273,
  274,  275,  276,  277,   -1,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,   -1,   -1,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  309,   -1,   -1,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,
  334,   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,   -1,
   -1,   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,  383,
  384,  385,   -1,   -1,   -1,  389,   -1,  391,   -1,   -1,
   -1,  395,  260,  261,  262,  399,  400,  265,  266,  267,
   -1,  269,   -1,   -1,  272,  273,  274,  275,  276,  277,
   -1,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,   -1,   -1,  293,   -1,   -1,   -1,   -1,
   -1,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,   -1,   -1,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,   -1,   -1,   -1,  333,  334,   -1,  336,  337,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,  376,   -1,
   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,   -1,
   -1,  389,   -1,  391,   -1,   -1,   -1,  395,  260,  261,
  262,  399,  400,  265,  266,  267,   -1,  269,   -1,   -1,
  272,  273,  274,  275,  276,  277,   -1,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
   -1,  293,   -1,   -1,   -1,   -1,   -1,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,   -1,   -1,
  312,  313,  314,  315,   -1,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,   -1,   -1,
   -1,  333,  334,   -1,  336,  337,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,
  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,  381,
   -1,  383,  384,  385,   -1,   -1,   -1,  389,   -1,  391,
   -1,   -1,   -1,  395,  260,  261,  262,  399,  400,  265,
  266,  267,   -1,  269,   -1,   -1,  272,  273,  274,  275,
  276,  277,   -1,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,   -1,   -1,  293,   -1,   -1,
   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  309,   -1,   -1,  312,  313,  314,  315,
   -1,   -1,  318,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,
  336,  337,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,
  376,   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,
   -1,   -1,   -1,  389,   -1,  391,   -1,   -1,   -1,  395,
   -1,   -1,   -1,  399,  400,   -1,   -1,  265,  266,   -1,
   -1,   -1,  335,   -1,   -1,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,   -1,  376,  377,  378,   -1,   -1,  381,   -1,
   -1,  384,  385,   -1,   -1,   -1,  389,  390,  391,  392,
  393,   -1,  395,  396,  265,  266,   -1,  268,   -1,  270,
   -1,  404,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,   -1,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,  374,   -1,  376,  377,
  378,   -1,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,
   -1,  389,   -1,  391,  392,  393,   -1,  395,   -1,   -1,
   -1,  266,   -1,  268,  335,  270,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,   -1,   -1,
  381,   -1,   -1,  384,  385,   -1,   -1,   -1,  389,  390,
  391,  392,  393,   -1,  395,  396,  265,  266,   -1,  268,
  335,  270,   -1,  404,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,   -1,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,  266,   -1,  268,   -1,  270,  335,   -1,   -1,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
   -1,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,   -1,
  389,  390,  391,  392,  393,   -1,  395,  396,  265,  266,
  335,  268,   -1,  270,  339,  404,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,   -1,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,   -1,   -1,   -1,   -1,  266,   -1,   -1,  335,  270,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,   -1,  376,
  377,  378,   -1,   -1,  381,   -1,   -1,  384,  385,   -1,
   -1,   -1,  389,  390,  391,  392,  393,   -1,  395,  396,
  265,  266,   -1,  268,   -1,  270,   -1,  404,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,   -1,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,   -1,  266,
  381,   -1,   -1,  384,  385,   -1,   -1,   -1,  389,   -1,
  391,  392,  393,   -1,  395,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,  265,  266,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,  355,  404,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,   -1,  376,
  377,  378,  266,   -1,  381,   -1,   -1,  384,  385,   -1,
   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  390,
   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
  374,   -1,  376,  377,  378,  266,   -1,  381,   -1,   -1,
  384,  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,
   -1,  395,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,   -1,  376,
  377,  378,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,  266,   -1,
  381,   -1,   -1,  384,  385,   -1,   -1,   -1,  389,   -1,
  391,  392,  393,   -1,  395,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,   -1,   -1,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,   -1,  376,  377,  378,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,
   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,  374,   -1,  376,  377,
  378,  266,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,
   -1,  389,   -1,  391,  392,  393,   -1,  395,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,  266,   -1,  381,   -1,   -1,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,  265,  266,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,   -1,  376,  377,  378,   -1,   -1,  381,
   -1,   -1,  384,  385,   -1,   -1,   -1,  389,   -1,  391,
  392,  393,   -1,  395,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,   -1,  376,  377,  378,  265,  266,
   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,  390,
   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  372,  373,  374,   -1,  376,
  377,  378,  265,  266,   -1,  268,   -1,  270,   -1,   -1,
   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  335,   -1,   -1,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,   -1,  376,  377,  378,  265,  266,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,
   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,  266,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,  260,  261,  262,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,  314,  315,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  265,   -1,   -1,
  268,   -1,  270,   -1,   -1,  358,   -1,   -1,  361,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,  372,
   -1,  396,   -1,  376,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  395,  396,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,  261,
  262,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,
   -1,   -1,   -1,   -1,  276,  277,  404,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  313,  314,  315,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  265,
   -1,   -1,  268,   -1,  270,   -1,  358,   -1,   -1,  361,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,
  372,   -1,   -1,   -1,  376,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  395,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,
   -1,   -1,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,
  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  265,   -1,   -1,
  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,
   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  265,   -1,   -1,  268,   -1,  270,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  265,   -1,   -1,  268,
   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  390,   -1,
   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  265,   -1,   -1,  268,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  265,   -1,   -1,  268,   -1,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  390,   -1,  265,   -1,   -1,  268,  396,  270,   -1,   -1,
   -1,   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,   -1,  335,   -1,   -1,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  265,  390,
   -1,  268,   -1,  270,   -1,  396,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  265,   -1,   -1,  268,  390,  270,   -1,
   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  335,   -1,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  335,   -1,   -1,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  265,   -1,   -1,
  268,   -1,  270,  390,   -1,   -1,   -1,   -1,   -1,  396,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  404,   -1,   -1,
  265,   -1,   -1,  268,   -1,  270,   -1,   -1,  390,   -1,
   -1,   -1,   -1,   -1,  396,   -1,   -1,  260,  261,  262,
   -1,   -1,  404,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  335,   -1,   -1,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  335,  314,  315,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  265,  356,   -1,  268,   -1,  270,   -1,   -1,   -1,   -1,
   -1,   -1,  390,   -1,   -1,   -1,   -1,   -1,  396,   -1,
   -1,   -1,   -1,   -1,   -1,  358,  404,   -1,  361,   -1,
   -1,   -1,   -1,   -1,   -1,  390,   -1,   -1,   -1,  372,
   -1,  396,   -1,  376,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  395,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  335,   -1,   -1,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
   -1,  356,   -1,  260,  261,  262,   -1,   -1,   -1,  266,
  267,   -1,  269,   -1,   -1,  272,  273,  274,  275,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,  390,   -1,   -1,   -1,   -1,
   -1,  396,  299,  300,   -1,   -1,   -1,   -1,   -1,  404,
   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,  336,
  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,  376,
   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,
   -1,   -1,  389,   -1,  391,  260,  261,  262,  395,   -1,
   -1,  266,   -1,   -1,  269,   -1,   -1,  272,  273,  274,
  275,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  299,  300,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,  314,
  315,   -1,   -1,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,
   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,
   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,  383,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  260,  261,  262,
  395,   -1,   -1,  266,  267,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,
  313,  314,  315,   -1,   -1,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,
  333,  334,  335,  336,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,
   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,
  383,  384,  385,   -1,   -1,   -1,  389,   -1,  391,  260,
  261,  262,  395,   -1,   -1,  266,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,  335,  336,  337,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,
  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  371,  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,
  381,   -1,  383,  384,  385,   -1,   -1,   -1,  389,   -1,
  391,  260,  261,  262,  395,   -1,   -1,  266,  267,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,   -1,   -1,   -1,  333,  334,   -1,  336,  337,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,
   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  371,  372,   -1,   -1,   -1,  376,   -1,   -1,
   -1,   -1,  381,   -1,  383,  384,  385,   -1,   -1,   -1,
  389,   -1,  391,  260,  261,  262,  395,   -1,   -1,  266,
   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,   -1,   -1,   -1,  333,  334,   -1,  336,
  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,  376,
   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,
   -1,   -1,  389,  390,  391,  260,  261,  262,  395,   -1,
   -1,  266,   -1,   -1,  269,  270,   -1,   -1,   -1,   -1,
   -1,  276,  277,   -1,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  313,  314,
  315,   -1,   -1,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,   -1,   -1,   -1,  333,  334,
   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,
   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,  383,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  260,  261,  262,
  395,   -1,   -1,  266,  267,   -1,  269,   -1,   -1,   -1,
   -1,   -1,   -1,  276,  277,   -1,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,
  313,  314,  315,   -1,   -1,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,   -1,   -1,   -1,
  333,  334,   -1,  336,  337,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,  361,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  371,  372,
   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,  381,   -1,
  383,  384,  385,   -1,   -1,   -1,  389,   -1,  391,  260,
  261,  262,  395,   -1,   -1,  266,   -1,   -1,  269,   -1,
   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,  313,  314,  315,   -1,   -1,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,   -1,
   -1,   -1,  333,  334,  335,  336,  337,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,   -1,
  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  371,  372,   -1,   -1,   -1,  376,   -1,   -1,   -1,   -1,
  381,   -1,  383,  384,  385,   -1,   -1,   -1,  389,   -1,
  391,  260,  261,  262,  395,   -1,   -1,  266,  267,   -1,
  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  309,   -1,   -1,   -1,  313,  314,  315,   -1,   -1,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,   -1,   -1,   -1,  333,  334,   -1,  336,  337,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  358,
   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  371,  372,   -1,   -1,   -1,  376,   -1,   -1,
   -1,   -1,  381,   -1,  383,  384,  385,   -1,   -1,   -1,
  389,   -1,  391,  260,  261,  262,  395,   -1,   -1,  266,
   -1,   -1,  269,   -1,   -1,   -1,   -1,   -1,   -1,  276,
  277,   -1,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  309,   -1,   -1,   -1,  313,  314,  315,   -1,
   -1,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  266,   -1,   -1,  333,  334,   -1,  336,
  337,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  358,   -1,   -1,  361,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  371,  372,   -1,   -1,   -1,  376,
   -1,   -1,   -1,   -1,  381,   -1,  383,  384,  385,   -1,
  266,   -1,  389,   -1,  391,   -1,   -1,   -1,  395,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,   -1,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
  373,  374,   -1,  376,  377,  378,   -1,  266,  381,   -1,
   -1,  384,  385,   -1,   -1,   -1,  389,   -1,  391,  392,
  393,   -1,  395,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
   -1,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,   -1,
  376,  377,  378,   -1,  266,  381,   -1,   -1,  384,  385,
   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,   -1,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
  266,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,   -1,
  389,   -1,  391,  392,  393,   -1,  395,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,   -1,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
  372,  373,  374,   -1,  376,  377,  378,   -1,   -1,  381,
   -1,  266,  384,  385,   -1,   -1,   -1,  389,   -1,  391,
  392,  393,   -1,  395,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
  356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,   -1,
  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,  385,
  266,   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,
  335,   -1,   -1,   -1,   -1,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,   -1,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
   -1,  376,  377,  378,   -1,   -1,  381,  266,   -1,  384,
  385,   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,
  395,   -1,   -1,  339,  340,  341,  342,  343,  344,  345,
  346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
   -1,  357,  358,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,  371,  372,  373,  374,   -1,
  376,  377,  378,   -1,   -1,  381,   -1,   -1,  384,  385,
   -1,   -1,   -1,  389,   -1,  391,  392,  393,   -1,  395,
   -1,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,   -1,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,   -1,  376,  377,  378,
   -1,   -1,  381,   -1,   -1,  384,  385,   -1,   -1,   -1,
  389,   -1,  391,  392,  393,   -1,  395,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 404
#define YYUNDFTOKEN 521
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"VAR","EXPR","ARRAY","STRUCT",
"UNION","ENUM","COMP","HASH","SEMI","MOD","OC","CC","DOLLAR","DOTDOTDOT",
"ENDFILE","GLOBAL","AUTO","STATIC","CONST","POLY","INTEGER","NATURAL",
"RATIONAL","REAL","STRING","FOREIGN","FILET","MUTEX","SEMAPHORE","CONTINUATION",
"THREAD","VOID","BOOL","FUNCTION","FUNC","EXCEPTION","RAISE","TYPEDEF","IMPORT",
"NEW","ANONINIT","NAMESPACE","PUBLIC","PROTECTED","EXTEND","WHILE","DO","FOR",
"SWITCH","BREAK","CONTINUE","RETURNTOK","FORK","CASE","DEFAULT","TWIXT","NAME",
"TYPENAME","NAMESPACENAME","COMMAND","NAMECOMMAND","TEN_NUM","OCTAL0_NUM",
"OCTAL_NUM","BINARY_NUM","HEX_NUM","TEN_FLOAT","OCTAL0_FLOAT","OCTAL_FLOAT",
"BINARY_FLOAT","HEX_FLOAT","CHAR_CONST","STRING_CONST","POLY_CONST",
"THREAD_CONST","COMMENT_CONST","VOIDVAL","BOOLVAL","DARROW","ISTYPE",
"HASMEMBER","POUND","COMMA","ASSIGN","ASSIGNPLUS","ASSIGNMINUS","ASSIGNTIMES",
"ASSIGNDIVIDE","ASSIGNDIV","ASSIGNMOD","ASSIGNPOW","ASSIGNSHIFTL",
"ASSIGNSHIFTR","ASSIGNLXOR","ASSIGNLAND","ASSIGNLOR","ASSIGNOR","ASSIGNAND",
"QUEST","COLON","OR","AND","LOR","LXOR","LAND","EQ","NE","LT","GT","LE","GE",
"SHIFTL","SHIFTR","PLUS","MINUS","TIMES","DIVIDE","DIV","POW","STARSTAR","POW2",
"POW3","UNIONCAST","UMINUS","BANG","FACT","LNOT","INC","DEC","STAR","AMPER",
"THREADID","OS","CS","DOT","ARROW","STAROS","CALL","OP","CP","POINTER",
"COLONCOLON","IF","TRY","NONL","ELSE","CATCH","NL",0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : lines",
"lines : lines pcommand",
"lines :",
"pcommand : command",
"pcommand : error reset eend",
"eend : NL",
"eend : SEMI",
"eend : ENDFILE",
"ignorenl :",
"attendnl :",
"reset :",
"not_command :",
"opt_nl : NL",
"opt_nl :",
"opt_semi : SEMI",
"opt_semi :",
"opt_comma : COMMA",
"opt_comma :",
"command : not_command expr reset NL",
"command : not_command expr POUND expr reset NL",
"command : not_command statement reset opt_nl",
"command : not_command COMMAND opt_exprs reset opt_semi NL",
"command : not_command NAMECOMMAND opt_rawnames reset opt_semi NL",
"command : NL",
"command : ENDFILE",
"opt_rawnames : rawnames",
"opt_rawnames :",
"rawnames : rawname COMMA rawnames",
"rawnames : rawname",
"rawname : rawnamespace rawatom",
"rawatom : NAME",
"rawatom : NAMESPACENAME",
"rawatom : TYPENAME",
"rawnamespace : rawnamespace rawatom COLONCOLON",
"rawnamespace :",
"fulltype : namespace TYPENAME",
"fulltype : TYPENAME",
"fullname : namespace namespacename",
"fullname : namespacename",
"fullnames : fullname",
"fullnames : fullname COMMA fullnames",
"namespace : namespace NAMESPACENAME COLONCOLON",
"namespace : NAMESPACENAME COLONCOLON",
"namespacename : NAME",
"namespacename : NAMESPACENAME",
"namespace_start :",
"namespace_end :",
"block : block_start statements block_end",
"block_start : OC namespace_start",
"block_end : namespace_end CC",
"statements : statement statements",
"statements :",
"if_statement : IF ignorenl namespace_start OP expr CP statement",
"if_statement : IF ignorenl namespace_start OP expr CP statement ELSE statement",
"statement : simple_statement",
"statement : block",
"simple_statement : if_statement namespace_end attendnl",
"simple_statement : WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"simple_statement : DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl",
"simple_statement : FOR ignorenl namespace_start OP for_exprs CP statement namespace_end attendnl",
"simple_statement : SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl",
"simple_statement : union_or_enum SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl",
"simple_statement : BREAK SEMI",
"simple_statement : CONTINUE SEMI",
"simple_statement : RETURNTOK opt_expr SEMI",
"simple_statement : expr SEMI",
"simple_statement : SEMI",
"simple_statement : func_decl doc_string opt_func_body namespace_end",
"simple_statement : opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end doc_string SEMI attendnl",
"simple_statement : RAISE fullname OP opt_exprs CP SEMI",
"simple_statement : opt_publish TYPEDEF ignorenl typenames SEMI attendnl",
"simple_statement : opt_publish TYPEDEF ignorenl type typenames SEMI attendnl",
"$$1 :",
"simple_statement : publish_extend NAMESPACE ignorenl namespacename $$1 OC statements CC attendnl",
"simple_statement : opt_publish IMPORT ignorenl fullnames SEMI attendnl",
"simple_statement : try_statement attendnl",
"simple_statement : TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"for_exprs : opt_expr SEMI for_exprs",
"for_exprs : opt_expr",
"try_body_statement : simple_statement",
"try_body_statement : OC statements CC",
"try_statement : TRY ignorenl try_body_statement catches",
"catches : catches catch",
"catches :",
"catch : CATCH fullname namespace_start args doc_string block namespace_end",
"opt_func_body : func_body",
"opt_func_body : SEMI",
"$$2 :",
"func_body : $$2 block_or_expr",
"block_or_expr : block",
"block_or_expr : attendnl ASSIGN simpleexpr SEMI",
"union_or_enum : UNION",
"union_or_enum : ENUM",
"see_comment :",
"doc_string : see_comment opt_comment",
"opt_comment : COMMENT_CONST",
"opt_comment :",
"case_block : block_start cases block_end",
"cases : case cases",
"cases :",
"case : CASE expr COLON statements",
"case : DEFAULT COLON statements",
"union_case_block : block_start union_cases block_end",
"union_cases : union_case union_cases",
"union_cases :",
"union_case : CASE namespace_start NAME opt_name COLON statements namespace_end",
"union_case : DEFAULT COLON statements",
"opt_name : NAME",
"opt_name :",
"atoms : NAME COMMA atoms",
"atoms : NAME",
"typenames : typename COMMA typenames",
"typenames : typename",
"typename : TYPENAME",
"typename : NAME",
"initnames : name opt_init next_decl initnames",
"initnames : name opt_init",
"name : NAME",
"next_decl : COMMA",
"func_decl : func_name namespace_start opt_argdefines CP",
"func_name : decl NAME OP",
"func_name : decl FUNCTION NAME OP",
"func_name : FUNCTION ignorenl NAME OP",
"opt_init : ASSIGN simpleexpr",
"opt_init : ASSIGN init",
"opt_init :",
"decl : publish opt_class opt_type opt_nl",
"decl : class opt_type opt_nl",
"decl : type opt_nl",
"subscripts : opt_argdecls subscripts",
"subscripts : OS opt_stars CS subscripts",
"subscripts : OS dotdotdots CS subscripts",
"subscripts : OS dims CS subscripts",
"subscripts : OS type CS subscripts",
"subscripts :",
"type : subtype subscripts",
"type : TIMES type",
"type : STARSTAR type",
"type : AND type",
"type : LAND type",
"type : type PLUS type",
"subtype : basetype",
"subtype : STRUCT OC struct_members CC",
"subtype : UNION OC union_members CC",
"subtype : ENUM OC atoms CC",
"subtype : OP type CP",
"subtype : fulltype",
"opt_type : type",
"opt_type :",
"basetype : POLY",
"basetype : INTEGER",
"basetype : RATIONAL",
"basetype : REAL",
"basetype : STRING",
"basetype : FILET",
"basetype : MUTEX",
"basetype : SEMAPHORE",
"basetype : CONTINUATION",
"basetype : THREAD",
"basetype : VOID",
"basetype : BOOL",
"basetype : FOREIGN",
"opt_stars : stars",
"opt_stars :",
"stars : stars COMMA TIMES",
"stars : TIMES",
"dotdotdots : dotdotdots COMMA DOTDOTDOT",
"dotdotdots : DOTDOTDOT",
"dims : simpleexpr COMMA dims",
"dims : simpleexpr",
"struct_members : opt_type atoms SEMI struct_members",
"struct_members :",
"union_members : opt_type atoms SEMI union_members",
"union_members :",
"opt_class : class",
"opt_class :",
"class : GLOBAL",
"class : AUTO",
"class : STATIC",
"class : CONST",
"opt_publish : publish",
"opt_publish :",
"publish : PUBLIC",
"publish : PROTECTED",
"publish_extend : opt_publish",
"publish_extend : EXTEND",
"opt_argdecls : OP argdecls CP",
"opt_argdecls : OP CP",
"argdecls : argdecl COMMA argdecls",
"argdecls : argdecl opt_dotdotdot",
"argdecl : type NAME",
"argdecl : type",
"args : OP opt_argdefines CP",
"opt_argdefines : ignorenl argdefines",
"opt_argdefines : ignorenl",
"argdefines : argdefine COMMA argdefines",
"argdefines : argdefine opt_dotdotdot",
"argdefine : opt_type NAME",
"argdefine : type",
"opt_dotdotdot : DOTDOTDOT",
"opt_dotdotdot :",
"opt_expr : expr",
"opt_expr :",
"expr : comma_expr",
"expr : decl initnames",
"comma_expr : simpleexpr",
"comma_expr : comma_expr COMMA simpleexpr",
"opt_exprs : exprs",
"opt_exprs :",
"exprs : simpleexpr COMMA exprs",
"exprs : simpleexpr",
"opt_actuals : actuals",
"opt_actuals :",
"actuals : simpleexpr COMMA actuals",
"actuals : simpleexpr opt_dotdotdot",
"func_right : attendnl ASSIGN simpleexpr",
"$$3 :",
"func_right : $$3 block",
"simpleexpr : simpleexpr assignop simpleexpr",
"simpleexpr : opt_type FUNC namespace_start args doc_string func_right namespace_end",
"simpleexpr : MOD integer",
"simpleexpr : TIMES simpleexpr",
"simpleexpr : STARSTAR simpleexpr",
"simpleexpr : LAND simpleexpr",
"simpleexpr : AND simpleexpr",
"simpleexpr : MINUS simpleexpr",
"simpleexpr : LNOT simpleexpr",
"simpleexpr : BANG simpleexpr",
"simpleexpr : simpleexpr BANG",
"simpleexpr : INC simpleexpr",
"simpleexpr : simpleexpr INC",
"simpleexpr : DEC simpleexpr",
"simpleexpr : simpleexpr DEC",
"simpleexpr : FORK simpleexpr",
"simpleexpr : simpleexpr PLUS simpleexpr",
"simpleexpr : simpleexpr MINUS simpleexpr",
"simpleexpr : simpleexpr TIMES simpleexpr",
"simpleexpr : simpleexpr DIVIDE simpleexpr",
"simpleexpr : simpleexpr DIV simpleexpr",
"simpleexpr : simpleexpr MOD simpleexpr",
"simpleexpr : simpleexpr STARSTAR simpleexpr",
"simpleexpr : simpleexpr POW2",
"simpleexpr : simpleexpr POW3",
"simpleexpr : simpleexpr SHIFTL simpleexpr",
"simpleexpr : simpleexpr SHIFTR simpleexpr",
"simpleexpr : simpleexpr QUEST simpleexpr COLON simpleexpr",
"simpleexpr : simpleexpr LXOR simpleexpr",
"simpleexpr : simpleexpr LAND simpleexpr",
"simpleexpr : simpleexpr LOR simpleexpr",
"simpleexpr : simpleexpr AND simpleexpr",
"simpleexpr : simpleexpr OR simpleexpr",
"simpleexpr : simpleexpr EQ simpleexpr",
"simpleexpr : simpleexpr NE simpleexpr",
"simpleexpr : simpleexpr LT simpleexpr",
"simpleexpr : simpleexpr GT simpleexpr",
"simpleexpr : simpleexpr LE simpleexpr",
"simpleexpr : simpleexpr GE simpleexpr",
"simpleexpr : fullname",
"simpleexpr : TEN_NUM",
"simpleexpr : OCTAL_NUM",
"simpleexpr : OCTAL0_NUM",
"simpleexpr : BINARY_NUM",
"simpleexpr : HEX_NUM",
"simpleexpr : TEN_FLOAT",
"simpleexpr : OCTAL_FLOAT",
"simpleexpr : OCTAL0_FLOAT",
"simpleexpr : BINARY_FLOAT",
"simpleexpr : HEX_FLOAT",
"simpleexpr : CHAR_CONST",
"simpleexpr : STRING_CONST",
"simpleexpr : VOIDVAL",
"simpleexpr : BOOLVAL",
"simpleexpr : OS CS",
"simpleexpr : OP type CP namespace_start init namespace_end",
"simpleexpr : OP OS stars CS CP namespace_start arrayinit namespace_end",
"simpleexpr : OP OS dims CS CP namespace_start opt_arrayinit namespace_end",
"simpleexpr : OP OS type CS CP namespace_start opt_hashinit namespace_end",
"simpleexpr : type DOT NAME",
"simpleexpr : OP type DOT NAME CP simpleexpr",
"simpleexpr : DOLLAR opt_integer",
"simpleexpr : DOT",
"simpleexpr : OP expr CP",
"simpleexpr : OP block CP",
"simpleexpr : simpleexpr STAROS dims CS",
"simpleexpr : simpleexpr OS dims CS",
"simpleexpr : simpleexpr OP opt_actuals CP",
"simpleexpr : ISTYPE OP simpleexpr COMMA type CP",
"simpleexpr : HASMEMBER OP simpleexpr COMMA NAME CP",
"simpleexpr : simpleexpr DOT NAME",
"simpleexpr : simpleexpr ARROW NAME",
"opt_integer : integer",
"opt_integer :",
"assignop : ASSIGNPLUS",
"assignop : ASSIGNMINUS",
"assignop : ASSIGNTIMES",
"assignop : ASSIGNDIVIDE",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"assignop : ASSIGNSHIFTL",
"assignop : ASSIGNSHIFTR",
"assignop : ASSIGNLXOR",
"assignop : ASSIGNLAND",
"assignop : ASSIGNLOR",
"assignop : ASSIGNOR",
"assignop : ASSIGNAND",
"assignop : ASSIGN",
"integer : TEN_NUM",
"integer : OCTAL_NUM",
"integer : OCTAL0_NUM",
"integer : BINARY_NUM",
"integer : HEX_NUM",
"opt_arrayinit : arrayinit",
"opt_arrayinit : OC CC",
"opt_arrayinit :",
"arrayinit : OC arrayelts opt_comma opt_dotdotdot CC",
"arrayinit : OC OS namespace_start compnames comparray CS comprehension namespace_end CC",
"comprehension : ASSIGN arrayelt",
"comprehension : block",
"compnames : compname COMMA compnames",
"compnames : compname",
"compname : NAME",
"comparray :",
"arrayelts : arrayelts COMMA arrayelt",
"arrayelts : arrayelt",
"arrayelt : simpleexpr",
"arrayelt : init",
"opt_hashinit : hashinit",
"opt_hashinit : OC CC",
"opt_hashinit :",
"hashinit : OC hashelts opt_comma CC",
"hashelts : hashelts COMMA hashelt",
"hashelts : hashelt",
"hashelt : simpleexpr DARROW hashvalue",
"hashelt : DARROW hashvalue",
"hashvalue : simpleexpr",
"hashvalue : init",
"structinit : OC structelts opt_comma CC",
"structelts : structelts COMMA structelt",
"structelts : structelt",
"structelt : NAME ASSIGN simpleexpr",
"structelt : NAME ASSIGN init",
"structelt : DOT NAME ASSIGN simpleexpr",
"structelt : DOT NAME ASSIGN init",
"init : arrayinit",
"init : structinit",
"init : hashinit",
"init : OC CC",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 1633 "gram.y"

static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp, CodePtr *cp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
    if (CurrentFrame)
	*cp = CurrentFrame->function->func.code;
    else
	*cp = 0;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk for() loop arguments and normalize the list
 */
static Expr *
ParseCanonFor (Expr *expr)
{
    if (!expr || !expr->tree.right) {
        ParseError ("Too few exprs in for()\n");
        return 0;
    }
    if (!expr->tree.right->tree.right) {
        /* 2-argument for() */
        expr = NewExprTree(FOR, 0, expr);
    }
    if (expr->tree.right->tree.right->tree.right) {
        ParseError ("Too many exprs in for()\n");
        return 0;
    }
    return expr;
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type, Void);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ignorenl = 0;
    ParseError ("%s before %S", msg, yytext);
}
#line 3024 "gram.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 5:
#line 198 "gram.y"
	{ yyerrok; }
break;
case 6:
#line 200 "gram.y"
	{ yyerrok; }
break;
case 7:
#line 202 "gram.y"
	{ yyerrok; }
break;
case 8:
#line 210 "gram.y"
	{ ignorenl++; }
break;
case 9:
#line 213 "gram.y"
	{ if (ignorenl > 0) ignorenl--; }
break;
case 10:
#line 216 "gram.y"
	{ 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
			lastThreadError = True;
		    }
break;
case 11:
#line 234 "gram.y"
	{ notCommand = 1; }
break;
case 18:
#line 249 "gram.y"
	{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, yystack.l_mark[-2].expr, 0));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 19:
#line 265 "gram.y"
	{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, yystack.l_mark[-4].expr, 0), yystack.l_mark[-2].expr);
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 20:
#line 281 "gram.y"
	{ 
			ENTER ();
			NamespacePtr    s;
			FramePtr	f;
			CodePtr		c;
			Value		t;
			
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileStat (yystack.l_mark[-2].expr, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 21:
#line 294 "gram.y"
	{
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yystack.l_mark[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yystack.l_mark[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yystack.l_mark[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 22:
#line 318 "gram.y"
	{
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yystack.l_mark[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yystack.l_mark[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yystack.l_mark[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 26:
#line 347 "gram.y"
	{ yyval.expr = 0; }
break;
case 27:
#line 350 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 28:
#line 352 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
break;
case 29:
#line 355 "gram.y"
	{ yyval.expr = BuildRawname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom); }
break;
case 33:
#line 362 "gram.y"
	{ yyval.expr = NewExprTree (COLONCOLON, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[-1].atom, 0, False)); }
break;
case 34:
#line 364 "gram.y"
	{ yyval.expr = 0; }
break;
case 35:
#line 367 "gram.y"
	{ 
			yyval.expr = BuildFullname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
break;
case 36:
#line 372 "gram.y"
	{ 
			yyval.expr = BuildFullname (0, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
break;
case 37:
#line 378 "gram.y"
	{ 
			yyval.expr = BuildFullname (yystack.l_mark[-1].expr, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
break;
case 38:
#line 383 "gram.y"
	{
			yyval.expr = BuildFullname (0, yystack.l_mark[0].atom);
			LexNamespace = 0;
		    }
break;
case 39:
#line 389 "gram.y"
	{
			yyval.expr = yystack.l_mark[0].expr;
		    }
break;
case 40:
#line 393 "gram.y"
	{
			yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr);
		    }
break;
case 41:
#line 398 "gram.y"
	{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (yystack.l_mark[-2].expr, yystack.l_mark[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 42:
#line 421 "gram.y"
	{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, yystack.l_mark[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yystack.l_mark[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 45:
#line 451 "gram.y"
	{ CurrentNamespace = NewNamespace (CurrentNamespace); }
break;
case 46:
#line 454 "gram.y"
	{ CurrentNamespace = CurrentNamespace->previous; }
break;
case 47:
#line 457 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 50:
#line 464 "gram.y"
	{ yyval.expr = NewExprTree(OC, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
break;
case 51:
#line 466 "gram.y"
	{ yyval.expr = NewExprTree(OC, 0, 0); }
break;
case 52:
#line 469 "gram.y"
	{ yyval.expr = NewExprTree(IF, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 53:
#line 471 "gram.y"
	{ yyval.expr = NewExprTree(ELSE, yystack.l_mark[-4].expr, NewExprTree(ELSE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); }
break;
case 56:
#line 478 "gram.y"
	{ yyval.expr = yystack.l_mark[-2].expr; }
break;
case 57:
#line 480 "gram.y"
	{ yyval.expr = NewExprTree(WHILE, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
break;
case 58:
#line 482 "gram.y"
	{ yyval.expr = NewExprTree(DO, yystack.l_mark[-6].expr, yystack.l_mark[-3].expr); }
break;
case 59:
#line 484 "gram.y"
	{ Expr *expr = ParseCanonFor(yystack.l_mark[-4].expr);
		      if (!expr)
                          YYERROR;
		      yyval.expr = NewExprTree(FOR, expr, yystack.l_mark[-2].expr); }
break;
case 60:
#line 489 "gram.y"
	{ yyval.expr = NewExprTree (SWITCH, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
break;
case 61:
#line 491 "gram.y"
	{ yyval.expr = NewExprTree (UNION, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
break;
case 62:
#line 493 "gram.y"
	{ yyval.expr = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
break;
case 63:
#line 495 "gram.y"
	{ yyval.expr = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
break;
case 64:
#line 497 "gram.y"
	{ yyval.expr = NewExprTree (RETURNTOK, (Expr *) 0, yystack.l_mark[-1].expr); }
break;
case 65:
#line 499 "gram.y"
	{ yyval.expr = NewExprTree(EXPR, yystack.l_mark[-1].expr, (Expr *) 0); }
break;
case 66:
#line 501 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
break;
case 67:
#line 503 "gram.y"
	{ 
			DeclList    *decl = yystack.l_mark[-3].funcDecl.decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = yystack.l_mark[-3].funcDecl.type.class;
			Publish	    publish = yystack.l_mark[-3].funcDecl.type.publish;
			TypePtr	    type = yystack.l_mark[-3].funcDecl.type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if (yystack.l_mark[-1].expr)
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       yystack.l_mark[-1].expr,
								       yystack.l_mark[-2].value),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			yyval.expr = NewExprDecl (FUNC, decl, class, type, publish);
		    }
break;
case 68:
#line 530 "gram.y"
	{ 
			DeclListPtr decl;

			decl = NewDeclList (yystack.l_mark[-6].atom, 0, 0);
			decl->symbol = ParseNewSymbol (yystack.l_mark[-9].publish, 
						       class_exception, 
						       typePoly, yystack.l_mark[-6].atom);
			decl->symbol->exception.doc = yystack.l_mark[-2].value;
			yyval.expr = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, yystack.l_mark[-4].argType),
					  yystack.l_mark[-9].publish);
		    }
break;
case 69:
#line 545 "gram.y"
	{ yyval.expr = NewExprTree (RAISE, yystack.l_mark[-4].expr, yystack.l_mark[-2].expr); }
break;
case 70:
#line 547 "gram.y"
	{ 
			DeclListPtr decl;

			for (decl = yystack.l_mark[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yystack.l_mark[-5].publish, class_typedef,
							   0, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yystack.l_mark[-2].declList, class_typedef, 0, yystack.l_mark[-5].publish), 0);
		    }
break;
case 71:
#line 556 "gram.y"
	{ 
			DeclListPtr decl;

			for (decl = yystack.l_mark[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yystack.l_mark[-6].publish, class_typedef,
							   yystack.l_mark[-3].type, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yystack.l_mark[-2].declList, class_typedef, yystack.l_mark[-3].type, yystack.l_mark[-6].publish), 0);
		    }
break;
case 72:
#line 565 "gram.y"
	{
			SymbolPtr   symbol;
			Publish	    publish = yystack.l_mark[-3].publish;
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			yystack.l_mark[-2].namespace = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, yystack.l_mark[0].atom, True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", yystack.l_mark[0].atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", yystack.l_mark[0].atom);
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol (yystack.l_mark[-3].publish, class_namespace,
						     0, yystack.l_mark[0].atom);
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != yystack.l_mark[-2].namespace)
			    CurrentNamespace->publish = publish_public;
		    }
break;
case 73:
#line 606 "gram.y"
	{
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != yystack.l_mark[-7].namespace)
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = yystack.l_mark[-7].namespace;
			yyval.expr = NewExprTree (NAMESPACE, NewExprAtom (yystack.l_mark[-5].atom, 0, False), yystack.l_mark[-2].expr);
		    }
break;
case 74:
#line 620 "gram.y"
	{
			SymbolPtr	symbol;
			ExprPtr		p, e, n;

			p = yystack.l_mark[-2].expr;
			for (p = yystack.l_mark[-2].expr; p; p = n)
			{
			    if (p->base.tag == COMMA)
			    {
				e = p->tree.left;
				n = p->tree.right;
			    }
			    else
			    {
				e = p;
				n = 0;
			    }
			    if (e->base.tag == COLONCOLON)
				e = e->tree.right;
			    symbol = e->atom.symbol;
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", e->atom.atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", e->atom.atom);
				YYERROR;
			    }
			    NamespaceImport (CurrentNamespace, 
					     symbol->namespace.namespace, yystack.l_mark[-5].publish);
			}
			yyval.expr = NewExprTree (IMPORT, yystack.l_mark[-2].expr, NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   yystack.l_mark[-5].publish));
		    }
break;
case 75:
#line 660 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 76:
#line 662 "gram.y"
	{ yyval.expr = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, yystack.l_mark[-6].expr, yystack.l_mark[-4].expr),
					NewExprTree (TWIXT, yystack.l_mark[-2].expr, 0));
		    }
break;
case 77:
#line 668 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 78:
#line 670 "gram.y"
	{ yyval.expr = NewExprTree(SEMI, yystack.l_mark[0].expr, 0); }
break;
case 80:
#line 675 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 81:
#line 678 "gram.y"
	{ yyval.expr = NewExprTree (CATCH, yystack.l_mark[0].expr, yystack.l_mark[-1].expr); }
break;
case 82:
#line 682 "gram.y"
	{ yyval.expr = NewExprTree (CATCH, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
break;
case 83:
#line 684 "gram.y"
	{ yyval.expr = 0; }
break;
case 84:
#line 687 "gram.y"
	{ yyval.expr = NewExprCode (NewFuncCode (typePrim[rep_void],
						     yystack.l_mark[-3].argType, yystack.l_mark[-1].expr, yystack.l_mark[-2].value),
					yystack.l_mark[-5].expr); 
		    }
break;
case 86:
#line 694 "gram.y"
	{ yyval.expr = 0; }
break;
case 87:
#line 696 "gram.y"
	{ ++funcDepth; }
break;
case 88:
#line 696 "gram.y"
	{ --funcDepth; yyval.expr = yystack.l_mark[0].expr; }
break;
case 89:
#line 699 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
break;
case 90:
#line 701 "gram.y"
	{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yystack.l_mark[-1].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 93:
#line 711 "gram.y"
	{ seeComment = 1; }
break;
case 94:
#line 714 "gram.y"
	{ seeComment = 0; yyval.value = yystack.l_mark[0].value; }
break;
case 96:
#line 718 "gram.y"
	{ yyval.value = Void; }
break;
case 97:
#line 721 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 98:
#line 724 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
break;
case 99:
#line 726 "gram.y"
	{ yyval.expr = 0; }
break;
case 100:
#line 729 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 101:
#line 731 "gram.y"
	{ yyval.expr = NewExprTree (CASE, 0, yystack.l_mark[0].expr); }
break;
case 102:
#line 734 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 103:
#line 737 "gram.y"
	{ yyval.expr = NewExprTree (CASE, yystack.l_mark[-1].expr, yystack.l_mark[0].expr); }
break;
case 104:
#line 739 "gram.y"
	{ yyval.expr = 0; }
break;
case 105:
#line 742 "gram.y"
	{ 
			SymbolPtr   sym = yystack.l_mark[-3].symbol;
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			yyval.expr = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom (yystack.l_mark[-4].atom, 0, False),
						       name),
					  yystack.l_mark[-1].expr);
		    }
break;
case 106:
#line 757 "gram.y"
	{ yyval.expr = NewExprTree (CASE, 0, yystack.l_mark[0].expr); }
break;
case 107:
#line 760 "gram.y"
	{
			yyval.symbol = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     yystack.l_mark[0].atom);
		    }
break;
case 108:
#line 767 "gram.y"
	{ yyval.symbol = 0; }
break;
case 109:
#line 773 "gram.y"
	{ yyval.atomList = NewAtomList (yystack.l_mark[0].atomList, yystack.l_mark[-2].atom); }
break;
case 110:
#line 775 "gram.y"
	{ yyval.atomList = NewAtomList (0, yystack.l_mark[0].atom); }
break;
case 111:
#line 778 "gram.y"
	{ yyval.declList = NewDeclList (yystack.l_mark[-2].atom, 0, yystack.l_mark[0].declList); }
break;
case 112:
#line 780 "gram.y"
	{ yyval.declList = NewDeclList (yystack.l_mark[0].atom, 0, 0); }
break;
case 115:
#line 794 "gram.y"
	{ 
			if (yystack.l_mark[-3].symbol)
			{
			    yyval.declList = NewDeclList (yystack.l_mark[-3].symbol->symbol.name, yystack.l_mark[-2].expr, yystack.l_mark[0].declList); 
			    yyval.declList->symbol = yystack.l_mark[-3].symbol;
			}
			else
			    yyval.declList = yystack.l_mark[0].declList;
		    }
break;
case 116:
#line 804 "gram.y"
	{ 
			if (yystack.l_mark[-1].symbol)
			{
			    yyval.declList = NewDeclList (yystack.l_mark[-1].symbol->symbol.name, yystack.l_mark[0].expr, 0);
			    yyval.declList->symbol = yystack.l_mark[-1].symbol;
			}
			else
			    yystack.l_mark[-1].symbol = 0;
		    }
break;
case 117:
#line 815 "gram.y"
	{	
			yyval.symbol = ParseNewSymbol (yystack.l_mark[-1].fulltype.publish,
					     yystack.l_mark[-1].fulltype.class,
					     yystack.l_mark[-1].fulltype.type,
					     yystack.l_mark[0].atom);
		    }
break;
case 118:
#line 827 "gram.y"
	{ yyval.fulltype = yystack.l_mark[-3].fulltype; }
break;
case 119:
#line 833 "gram.y"
	{
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc (yystack.l_mark[-3].funcDecl.type.type, yystack.l_mark[-1].argType);
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, yystack.l_mark[-3].funcDecl.decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    yystack.l_mark[-3].funcDecl.decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol (yystack.l_mark[-3].funcDecl.type.publish,
						     yystack.l_mark[-3].funcDecl.type.class, 
						     type,
						     yystack.l_mark[-3].funcDecl.decl->name);
			}
			CurrentNamespace = save;
			yyval.funcDecl = yystack.l_mark[-3].funcDecl;
			yyval.funcDecl.decl->symbol = symbol;
			yyval.funcDecl.type.type = type;
		    }
break;
case 120:
#line 866 "gram.y"
	{ yyval.funcDecl.type = yystack.l_mark[-2].fulltype; yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); }
break;
case 121:
#line 868 "gram.y"
	{ yyval.funcDecl.type = yystack.l_mark[-3].fulltype; yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); }
break;
case 122:
#line 870 "gram.y"
	{ 
			yyval.funcDecl.type.publish = publish_private;
			yyval.funcDecl.type.class = class_undef;
			yyval.funcDecl.type.type = typePoly;
			yyval.funcDecl.decl = NewDeclList (yystack.l_mark[-1].atom, 0, 0); 
		    }
break;
case 123:
#line 878 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
break;
case 124:
#line 880 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
break;
case 125:
#line 882 "gram.y"
	{ yyval.expr = 0; }
break;
case 126:
#line 888 "gram.y"
	{ yyval.fulltype.publish = yystack.l_mark[-3].publish; yyval.fulltype.class = yystack.l_mark[-2].class; yyval.fulltype.type = yystack.l_mark[-1].type; }
break;
case 127:
#line 890 "gram.y"
	{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yystack.l_mark[-2].class; yyval.fulltype.type = yystack.l_mark[-1].type; }
break;
case 128:
#line 892 "gram.y"
	{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = class_undef; yyval.fulltype.type = yystack.l_mark[-1].type; }
break;
case 129:
#line 898 "gram.y"
	{ yyval.type = NewTypeFunc (yystack.l_mark[0].type, yystack.l_mark[-1].argType); }
break;
case 130:
#line 900 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, False); }
break;
case 131:
#line 902 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, True); }
break;
case 132:
#line 904 "gram.y"
	{ yyval.type = NewTypeArray (yystack.l_mark[0].type, yystack.l_mark[-2].expr, False); }
break;
case 133:
#line 906 "gram.y"
	{ yyval.type = NewTypeHash (yystack.l_mark[0].type, yystack.l_mark[-2].type); }
break;
case 134:
#line 908 "gram.y"
	{ yyval.type = 0; }
break;
case 135:
#line 911 "gram.y"
	{
			Type	*top = yystack.l_mark[0].type;
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = yystack.l_mark[-1].type;
			yyval.type = top;
		    }
break;
case 136:
#line 939 "gram.y"
	{ yyval.type = NewTypeRef (yystack.l_mark[0].type, True); }
break;
case 137:
#line 941 "gram.y"
	{ yyval.type = NewTypeRef (NewTypeRef (yystack.l_mark[0].type, True), True); }
break;
case 138:
#line 943 "gram.y"
	{ yyval.type = NewTypeRef (NewTypeRef (yystack.l_mark[0].type, False), False); }
break;
case 139:
#line 945 "gram.y"
	{ yyval.type = NewTypeRef (yystack.l_mark[0].type, False); }
break;
case 140:
#line 947 "gram.y"
	{ 
			if (ParseCanonType (yystack.l_mark[-2].type, False) != CanonTypeDefined)
			    YYERROR;
			if (ParseCanonType (yystack.l_mark[0].type, False) != CanonTypeDefined)
			    YYERROR;
			yyval.type = NewTypePlus (yystack.l_mark[-2].type, yystack.l_mark[0].type); 
			if (!yyval.type)
			    YYERROR;
		    }
break;
case 142:
#line 959 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeStruct (st);
		    }
break;
case 143:
#line 985 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yystack.l_mark[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeUnion (st, False);
		    }
break;
case 144:
#line 1011 "gram.y"
	{
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = yystack.l_mark[-1].atomList; al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = yystack.l_mark[-1].atomList; al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			yyval.type = NewTypeUnion (st, True);
		    }
break;
case 145:
#line 1032 "gram.y"
	{ yyval.type = yystack.l_mark[-1].type; }
break;
case 146:
#line 1034 "gram.y"
	{ yyval.type = NewTypeName (yystack.l_mark[0].expr, 0); }
break;
case 148:
#line 1038 "gram.y"
	{ yyval.type = typePoly; }
break;
case 163:
#line 1056 "gram.y"
	{ yyval.expr = 0; }
break;
case 164:
#line 1059 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[-2].expr); }
break;
case 165:
#line 1061 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 166:
#line 1064 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[-2].expr); }
break;
case 167:
#line 1066 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 168:
#line 1069 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 169:
#line 1071 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
break;
case 170:
#line 1077 "gram.y"
	{ yyval.memList = NewMemList (yystack.l_mark[-2].atomList, yystack.l_mark[-3].type, yystack.l_mark[0].memList); }
break;
case 171:
#line 1079 "gram.y"
	{ yyval.memList = 0; }
break;
case 172:
#line 1082 "gram.y"
	{ yyval.memList = NewMemList (yystack.l_mark[-2].atomList, yystack.l_mark[-3].type, yystack.l_mark[0].memList); }
break;
case 173:
#line 1084 "gram.y"
	{ yyval.memList = 0; }
break;
case 175:
#line 1091 "gram.y"
	{ yyval.class = class_undef; }
break;
case 181:
#line 1100 "gram.y"
	{ yyval.publish = publish_private; }
break;
case 186:
#line 1114 "gram.y"
	{ yyval.argType = yystack.l_mark[-1].argType; }
break;
case 187:
#line 1116 "gram.y"
	{ yyval.argType = 0; }
break;
case 188:
#line 1119 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-2].argDecl.type, False, yystack.l_mark[-2].argDecl.name, 0, yystack.l_mark[0].argType); }
break;
case 189:
#line 1121 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-1].argDecl.type, yystack.l_mark[0].bool, yystack.l_mark[-1].argDecl.name, 0, 0); }
break;
case 190:
#line 1124 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-1].type, False);
			yyval.argDecl.type = yystack.l_mark[-1].type; 
			yyval.argDecl.name = yystack.l_mark[0].atom; 
		    }
break;
case 191:
#line 1130 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[0].type, False);
			yyval.argDecl.type = yystack.l_mark[0].type;
			yyval.argDecl.name = 0; 
		    }
break;
case 192:
#line 1141 "gram.y"
	{ yyval.argType = yystack.l_mark[-1].argType; }
break;
case 193:
#line 1144 "gram.y"
	{
			ArgType	*args;
			Type	*type;

			for (args = yystack.l_mark[0].argType; args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			yyval.argType = yystack.l_mark[0].argType;
		    }
break;
case 194:
#line 1169 "gram.y"
	{ yyval.argType = 0; }
break;
case 195:
#line 1172 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-2].argDecl.type, False, yystack.l_mark[-2].argDecl.name, 0, yystack.l_mark[0].argType); }
break;
case 196:
#line 1174 "gram.y"
	{ yyval.argType = NewArgType (yystack.l_mark[-1].argDecl.type, yystack.l_mark[0].bool, yystack.l_mark[-1].argDecl.name, 0, 0); }
break;
case 197:
#line 1177 "gram.y"
	{ yyval.argDecl.type = yystack.l_mark[-1].type; yyval.argDecl.name = yystack.l_mark[0].atom; }
break;
case 198:
#line 1179 "gram.y"
	{ yyval.argDecl.type = yystack.l_mark[0].type; yyval.argDecl.name = 0; }
break;
case 199:
#line 1182 "gram.y"
	{ yyval.bool = True; }
break;
case 200:
#line 1184 "gram.y"
	{ yyval.bool = False; }
break;
case 202:
#line 1192 "gram.y"
	{ yyval.expr = 0; }
break;
case 204:
#line 1196 "gram.y"
	{ 
			DeclList    *decl;

			for (decl = yystack.l_mark[0].declList; decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = yystack.l_mark[-1].fulltype.type;
			    }
			}

			yyval.expr = NewExprDecl (VAR, yystack.l_mark[0].declList, yystack.l_mark[-1].fulltype.class, yystack.l_mark[-1].fulltype.type, yystack.l_mark[-1].fulltype.publish); 
		    }
break;
case 206:
#line 1213 "gram.y"
	{ yyval.expr = NewExprTree(COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 208:
#line 1220 "gram.y"
	{ yyval.expr = 0; }
break;
case 209:
#line 1223 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 210:
#line 1225 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[0].expr, 0); }
break;
case 212:
#line 1229 "gram.y"
	{ yyval.expr = 0; }
break;
case 213:
#line 1232 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 214:
#line 1234 "gram.y"
	{	
			ExprPtr	arg = yystack.l_mark[0].bool ? NewExprTree (DOTDOTDOT, yystack.l_mark[-1].expr, 0) : yystack.l_mark[-1].expr;
			yyval.expr = NewExprTree (COMMA, arg, 0); 
		    }
break;
case 215:
#line 1240 "gram.y"
	{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yystack.l_mark[0].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 216:
#line 1245 "gram.y"
	{ ++funcDepth; }
break;
case 217:
#line 1245 "gram.y"
	{ --funcDepth; yyval.expr = yystack.l_mark[0].expr; }
break;
case 218:
#line 1251 "gram.y"
	{ 
			if (yystack.l_mark[-1].ints == ASSIGNPOW)
			    yyval.expr = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr));
			else
			{
			    ExprPtr left = yystack.l_mark[-2].expr;
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if (yystack.l_mark[-1].ints == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				yystack.l_mark[-2].expr->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  yystack.l_mark[-2].expr->atom.atom);
			    }
			    yyval.expr = NewExprTree(yystack.l_mark[-1].ints, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); 
			}
		    }
break;
case 219:
#line 1277 "gram.y"
	{
			ParseCanonType (yystack.l_mark[-6].type, False);
			yyval.expr = NewExprCode (NewFuncCode (yystack.l_mark[-6].type, yystack.l_mark[-3].argType, yystack.l_mark[-1].expr, yystack.l_mark[-2].value), 0); 
		    }
break;
case 220:
#line 1282 "gram.y"
	{   Value	t;
			t = do_Thread_id_to_thread (yystack.l_mark[0].value);
			if (t == Void)
			{
			    ParseError ("No thread %v", yystack.l_mark[0].value);
			    YYERROR;
			}
			else
			    yyval.expr = NewExprConst(THREAD_CONST, t); 
		    }
break;
case 221:
#line 1293 "gram.y"
	{ yyval.expr = NewExprTree(STAR, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 222:
#line 1295 "gram.y"
	{ yyval.expr = NewExprTree(STAR, NewExprTree (STAR, yystack.l_mark[0].expr, 0), 0); }
break;
case 223:
#line 1297 "gram.y"
	{ yyval.expr = NewExprTree(AMPER, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 224:
#line 1299 "gram.y"
	{ yyval.expr = NewExprTree(AMPER, 
				       NewExprTree (AMPER, yystack.l_mark[0].expr, (Expr *) 0), 
				       (Expr *) 0); }
break;
case 225:
#line 1303 "gram.y"
	{ yyval.expr = NewExprTree(UMINUS, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 226:
#line 1305 "gram.y"
	{ yyval.expr = NewExprTree(LNOT, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 227:
#line 1307 "gram.y"
	{ yyval.expr = NewExprTree(BANG, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 228:
#line 1309 "gram.y"
	{ 
			yyval.expr = NewExprTree(FACT, 
					 BuildName ("Math", "factorial"),
					 yystack.l_mark[-1].expr);
		    }
break;
case 229:
#line 1315 "gram.y"
	{ yyval.expr = NewExprTree(INC, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 230:
#line 1317 "gram.y"
	{ yyval.expr = NewExprTree(INC, (Expr *) 0, yystack.l_mark[-1].expr); }
break;
case 231:
#line 1319 "gram.y"
	{ yyval.expr = NewExprTree(DEC, yystack.l_mark[0].expr, (Expr *) 0); }
break;
case 232:
#line 1321 "gram.y"
	{ yyval.expr = NewExprTree(DEC, (Expr *) 0, yystack.l_mark[-1].expr); }
break;
case 233:
#line 1323 "gram.y"
	{ yyval.expr = NewExprTree (FORK, (Expr *) 0, yystack.l_mark[0].expr); }
break;
case 234:
#line 1325 "gram.y"
	{ yyval.expr = NewExprTree(PLUS, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 235:
#line 1327 "gram.y"
	{ yyval.expr = NewExprTree(MINUS, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 236:
#line 1329 "gram.y"
	{ yyval.expr = NewExprTree(TIMES, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 237:
#line 1331 "gram.y"
	{ yyval.expr = NewExprTree(DIVIDE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 238:
#line 1333 "gram.y"
	{ yyval.expr = NewExprTree(DIV, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 239:
#line 1335 "gram.y"
	{ yyval.expr = NewExprTree(MOD, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 240:
#line 1337 "gram.y"
	{ 
			yyval.expr = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); 
		    }
break;
case 241:
#line 1343 "gram.y"
	{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yystack.l_mark[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(2))));
		    }
break;
case 242:
#line 1351 "gram.y"
	{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yystack.l_mark[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(3))));
		    }
break;
case 243:
#line 1359 "gram.y"
	{ yyval.expr = NewExprTree(SHIFTL, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 244:
#line 1361 "gram.y"
	{ yyval.expr = NewExprTree(SHIFTR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 245:
#line 1363 "gram.y"
	{ yyval.expr = NewExprTree(QUEST, yystack.l_mark[-4].expr, NewExprTree(COLON, yystack.l_mark[-2].expr, yystack.l_mark[0].expr)); }
break;
case 246:
#line 1365 "gram.y"
	{ yyval.expr = NewExprTree(LXOR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 247:
#line 1367 "gram.y"
	{ yyval.expr = NewExprTree(LAND, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 248:
#line 1369 "gram.y"
	{ yyval.expr = NewExprTree(LOR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 249:
#line 1371 "gram.y"
	{ yyval.expr = NewExprTree(AND, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 250:
#line 1373 "gram.y"
	{ yyval.expr = NewExprTree(OR, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 251:
#line 1375 "gram.y"
	{ yyval.expr = NewExprTree(EQ, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 252:
#line 1377 "gram.y"
	{ yyval.expr = NewExprTree(NE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 253:
#line 1379 "gram.y"
	{ yyval.expr = NewExprTree(LT, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 254:
#line 1381 "gram.y"
	{ yyval.expr = NewExprTree(GT, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 255:
#line 1383 "gram.y"
	{ yyval.expr = NewExprTree(LE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 256:
#line 1385 "gram.y"
	{ yyval.expr = NewExprTree(GE, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 258:
#line 1388 "gram.y"
	{ yyval.expr = NewExprConst(TEN_NUM, yystack.l_mark[0].value); }
break;
case 259:
#line 1390 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL_NUM, yystack.l_mark[0].value); }
break;
case 260:
#line 1392 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL0_NUM, yystack.l_mark[0].value); }
break;
case 261:
#line 1394 "gram.y"
	{ yyval.expr = NewExprConst(BINARY_NUM, yystack.l_mark[0].value); }
break;
case 262:
#line 1396 "gram.y"
	{ yyval.expr = NewExprConst(HEX_NUM, yystack.l_mark[0].value); }
break;
case 263:
#line 1398 "gram.y"
	{ yyval.expr = NewExprConst(TEN_FLOAT, yystack.l_mark[0].value); }
break;
case 264:
#line 1400 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL_FLOAT, yystack.l_mark[0].value); }
break;
case 265:
#line 1402 "gram.y"
	{ yyval.expr = NewExprConst(OCTAL0_FLOAT, yystack.l_mark[0].value); }
break;
case 266:
#line 1404 "gram.y"
	{ yyval.expr = NewExprConst(BINARY_FLOAT, yystack.l_mark[0].value); }
break;
case 267:
#line 1406 "gram.y"
	{ yyval.expr = NewExprConst(HEX_FLOAT, yystack.l_mark[0].value); }
break;
case 268:
#line 1408 "gram.y"
	{ yyval.expr = NewExprConst(CHAR_CONST, yystack.l_mark[0].value); }
break;
case 269:
#line 1410 "gram.y"
	{ yyval.expr = NewExprConst(STRING_CONST, yystack.l_mark[0].value); }
break;
case 270:
#line 1412 "gram.y"
	{ yyval.expr = NewExprConst(VOIDVAL, yystack.l_mark[0].value); }
break;
case 271:
#line 1414 "gram.y"
	{ yyval.expr = NewExprConst(BOOLVAL, yystack.l_mark[0].value); }
break;
case 272:
#line 1416 "gram.y"
	{ 
			yyval.expr = BuildFullname (0, AtomId ("[]"));
		    }
break;
case 273:
#line 1420 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-4].type, False);
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = yystack.l_mark[-4].type;
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0);
			yyval.expr->base.type = yystack.l_mark[-4].type;
		    }
break;
case 274:
#line 1428 "gram.y"
	{ 
			yystack.l_mark[-1].expr->base.type = NewTypeArray (typePoly, yystack.l_mark[-5].expr, True); 
			ParseCanonType (yystack.l_mark[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0); 
			yyval.expr->base.type = yystack.l_mark[-1].expr->base.type;
		    }
break;
case 275:
#line 1435 "gram.y"
	{ 
			TypePtr	t = NewTypeArray (typePoly, yystack.l_mark[-5].expr, False);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0); 
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 276:
#line 1444 "gram.y"
	{
			TypePtr t = NewTypeHash (typePoly, yystack.l_mark[-5].type);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yystack.l_mark[-1].expr, 0);
			if (yystack.l_mark[-1].expr)
			    yystack.l_mark[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 277:
#line 1453 "gram.y"
	{
			ParseCanonType (yystack.l_mark[-2].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yystack.l_mark[0].atom, 0, False), 0); 
			yyval.expr->base.type = yystack.l_mark[-2].type;
		    }
break;
case 278:
#line 1459 "gram.y"
	{ 
			ParseCanonType (yystack.l_mark[-4].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); 
			yyval.expr->base.type = yystack.l_mark[-4].type;
		    }
break;
case 279:
#line 1465 "gram.y"
	{ yyval.expr = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, yystack.l_mark[0].value)); }
break;
case 280:
#line 1467 "gram.y"
	{ yyval.expr = NewExprTree (DOLLAR, 0, 0); }
break;
case 281:
#line 1469 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 282:
#line 1471 "gram.y"
	{ yyval.expr = yystack.l_mark[-1].expr; }
break;
case 283:
#line 1473 "gram.y"
	{ yyval.expr = NewExprTree (OS, NewExprTree (STAR, yystack.l_mark[-3].expr, (Expr *) 0), yystack.l_mark[-1].expr); }
break;
case 284:
#line 1475 "gram.y"
	{ yyval.expr = NewExprTree(OS, yystack.l_mark[-3].expr, yystack.l_mark[-1].expr); }
break;
case 285:
#line 1477 "gram.y"
	{ yyval.expr = NewExprTree (OP, yystack.l_mark[-3].expr, yystack.l_mark[-1].expr); }
break;
case 286:
#line 1479 "gram.y"
	{
			TypePtr	type = yystack.l_mark[-1].type;
			ParseCanonType (type, False);
			yyval.expr = NewExprType (ISTYPE, yystack.l_mark[-3].expr, type);
		    }
break;
case 287:
#line 1485 "gram.y"
	{ yyval.expr = NewExprTree (HASMEMBER, yystack.l_mark[-3].expr, NewExprAtom(yystack.l_mark[-1].atom, 0, False)); }
break;
case 288:
#line 1487 "gram.y"
	{ yyval.expr = NewExprTree(DOT, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[0].atom, 0, False)); }
break;
case 289:
#line 1489 "gram.y"
	{ yyval.expr = NewExprTree(ARROW, yystack.l_mark[-2].expr, NewExprAtom (yystack.l_mark[0].atom, 0, False)); }
break;
case 291:
#line 1493 "gram.y"
	{ yyval.value = Zero; }
break;
case 313:
#line 1521 "gram.y"
	{ yyval.expr = 0; }
break;
case 314:
#line 1523 "gram.y"
	{ yyval.expr = 0; }
break;
case 315:
#line 1526 "gram.y"
	{ 
			ExprPtr	elts = yystack.l_mark[-3].expr ? ExprRehang (yystack.l_mark[-3].expr, 0) : 0;
			if (yystack.l_mark[-1].bool)
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			yyval.expr = NewExprTree (ARRAY, elts, 0); 
		    }
break;
case 316:
#line 1540 "gram.y"
	{
			yyval.expr = NewExprTree (COMP, NewExprTree (COMP, yystack.l_mark[-5].expr, yystack.l_mark[-4].expr), yystack.l_mark[-2].expr);
		    }
break;
case 317:
#line 1545 "gram.y"
	{ yyval.expr = yystack.l_mark[0].expr; }
break;
case 319:
#line 1549 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 321:
#line 1553 "gram.y"
	{ 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], yystack.l_mark[0].atom);
			yyval.expr = NewExprAtom (yystack.l_mark[0].atom, s, False); 
		    }
break;
case 322:
#line 1561 "gram.y"
	{
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			yyval.expr = NewExprAtom (a, s, False);
		    }
break;
case 323:
#line 1570 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 324:
#line 1572 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
break;
case 328:
#line 1583 "gram.y"
	{ yyval.expr = 0; }
break;
case 329:
#line 1585 "gram.y"
	{ yyval.expr = 0; }
break;
case 330:
#line 1588 "gram.y"
	{
			ExprPtr elts = yystack.l_mark[-2].expr ? ExprRehang (yystack.l_mark[-2].expr, 0) : 0;
			yyval.expr = NewExprTree (HASH, elts, 0);
		    }
break;
case 331:
#line 1594 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 332:
#line 1596 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
break;
case 333:
#line 1599 "gram.y"
	{ yyval.expr = NewExprTree (DARROW, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 334:
#line 1601 "gram.y"
	{ yyval.expr = NewExprTree (DARROW, 0, yystack.l_mark[0].expr); }
break;
case 337:
#line 1610 "gram.y"
	{ yyval.expr = NewExprTree (STRUCT, ExprRehang (yystack.l_mark[-2].expr, 0), 0); }
break;
case 338:
#line 1613 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, yystack.l_mark[-2].expr, yystack.l_mark[0].expr); }
break;
case 339:
#line 1615 "gram.y"
	{ yyval.expr = NewExprTree (COMMA, 0, yystack.l_mark[0].expr); }
break;
case 340:
#line 1618 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
break;
case 341:
#line 1620 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
break;
case 342:
#line 1622 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
break;
case 343:
#line 1624 "gram.y"
	{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yystack.l_mark[-2].atom, 0, False), yystack.l_mark[0].expr); }
break;
case 347:
#line 1630 "gram.y"
	{ yyval.expr = NewExprTree (ANONINIT, 0, 0); }
break;
#line 4895 "gram.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                yys = yyname[YYTRANSLATE(yychar)];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
